ECSK := module()
option package;
export 

##########################################################################################
# License: Apache License, Version 2.0
# Copyright [2023] [Joshua James Leiter]
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
##########################################################################################

#Update: 7/23/2020
#Made a module for Using ECSK theory
#End Update: 7/23/2020

#Update 4/21/2021
#Made an Affine connection on a spinor bundle "AffineSpinConnection".
#It takes entries (solderform,torsion=...,connectiontype='').
#To have it include torsion you muse put the torsion=T, where T is a prior defined torsion tensor.
#
#I have also added a command to do lorentz transformations/etc on the base space of a Fiber Bundle.
#This command is called "FiberedPrimitiveInducedLinearTransformationOnTensors".
#Given a linear transformation structure A, we can do linear transformation on the base space of Fiber Bundles!
#End Update: 4/21/2021

#Update 5/10/2021
#Added a SpinorHook program that takes an input (solderform,tensor) and converts a totally base tensor to a spinor.
#It can also go the other way and take a spinor as the input in the second slot and convert it to a tensor.
#End Update: 5/10/2021

#Update 9/20/2021
#Added an AlphonseTensor program which calculates the Alphonse tensor defined as the difference between a Metric affine curvature
#tensor and a Levi-civita curvature tensor.
#End Update: 9/20/2021

#Update 9/26/2021
#Added a totally symmetric trace decomposition code. Might make this into a different module.
#End Update: 9/26/2021

#Update 9/28/2021
#Updated tensor decomposition code doe third rank tensors. Created code for hermitian spinors compatible with SpinorHook.
#JoshConjugateSpinor is a code to take the conjugate of a spinor and put it in canonical form.
#ConstructHermitianSpinor is a code taking an input of a number (the dimension)
# and forms a hermitian spinor that is equivalent to that number. I.e. T_AA^'->T_a etc.
#End Update: 9/28/2021

#Update 10/25/2021
#Added SO(N) tensor decomposition code for 4th rank tensors
#This contains 22 different sectors.
#End Update: 10/25/2021

#Update 11/5/2021
#Renamed the Rank 3 guys to Trace/Frank, and changed some evalDG's to &minus
#End Update: 11/5/2021

#Update 11/9/2021
#Made the code in the Rank3 Tensor decomp's look nicer, and have added code for Rank3 Spinor decomp. See 39-52
#Also added a torsion trace decomp code (see 53-55), and a torsion spinor decomp code (see) :) 56-61
#End Update: 11/9/2021

#Update 11/15/2021
#Corrected 4th rank tensor decomposition code, and added 3 more pieces to the code for the extra Y2 sector pieces I discovered.
#I also rearranged the code order to make 2 extra modules, one to SO(N) decompose Rank 3 tensors, and the other to SO(N) decompose Rank 4 tensors.
#These new modules are called "Rank3TensorModule" and "Rank4TensorModule".
#End Update: 11/15/2021

#Update 11/19/2021
#Changed "AlphonseTensor" code to use the "ContorsionTensor" Code.
#End Update: 11/15/2021

#Update 12/25/2021 *It is Christmas!!!*
#I have added the 50 different commands for the Spinor Irreducible Representations of a 4th Rank Tensor
#End Update 12/25/2021

#Update 1/6/2022
#I have polished the 50 commands from 12/25/2021 & made it so you can also get conjugate spinors.
#This was important for calculations regarding the Alphonse Tensor.
#On that note, I also added code to generate the irreducible spinors and tensors of the Alphonse Tensor.
#End Update 1/6/2022

#Update 1/26/2022
#I updated the ContorsionTensor command (1), to allow for a cov,cov,cov type input in the first spot.
#Also added code to make TorsionOmegaSpinor (28) return a barspinor version.
#Also added code to make TorsionGenerateOmegaTensor (31) use an optional barspinor argument.
#Also updated (15-16) to make barspinors & (22-23) to have an optional barspinor arguement.
#Keeping with it... for TorsionGenerate... (30-32) I added an option to make the corresponding Contorsion piece.
#End Update 1/26/2022

#Update 3/14/2022
#Changed GammaJosh to Gamma (Was a typo) in AffineRicciScalar (3).
#End Update 3/14/2022

#Update 4/20/2022
#Updated Rank3GenerateXiTensor to work correctly when the Xi spinor is zero.
#All I did was change evalDG to &plus and  &minus.
#End Update 4/20/2022

#Update 4/21/2022
#Updated MetricAffineConnection to take the contorsion tensor as an input also.
#End Update 4/21/2022

#Update 7/19/2022
#Updated AffineSpinConnection to have the required frame input in DGzero.
#End Update 7/19/2022

#Update 7/27/2022
#Added JoshSolderForm(89)to get rid of dimension issue in DG. Also updated AffineSpinConnection(4) for the same purpose.
#Also added JoshSpinorInnerProduct(91), and JoshRaiseLowerSpinorIndices(90) to handle the dimension issue.
#Also adjusted SpinorHook to handle the dimension issue.
#End Update 7/27/2022

#Update 7/28/2022
#Updated SpinorHook(8) to impose compatibility with convert(..,DGspinor) & convert(..,DGtensor)
#Also checked old code for Rank3 & Rank4 tensors in Maple files that decompose tensors. 
#This update was super long because of going through the "Decomposing a Rank 3 Tensor" & "Decomposing a Rank 4 Tensor" &
#The Torsion and Alphonse tensor files as well.
#Additionally I had to update each of the commands in the ECSK package as well.
#Done with Rank 3 & Torsion Commands Update
#Now for the Rank 4 guys. Finished up till the Omicron Y2c guy.
#End Update ...... 7/28/2022

#Update 7/29/2022
#Working on the Rank 4 guys, Finished "Decomposing a Rank 4 Tensor" & "Decomposing the Alphonse Tensor"
#Edited SpinorHook to also work on orthonormal indices.
#End Update ...... 7/29/2022

#Update 8/19/2022
#Added code for Rank 2 spinors and Generate Rank 2 tensors from spinors
#End Update 8/19/2022

#Update 8/25/2022
#Updated AffineRicciScalar, #3, to take a metric, g and a torsion tensor T as its arguements
#End Update 8/25/2022

#Update 8/25/2022
#Added number 98: PlebanskiSpinorClassification, which returns the Plebanski type given a Ricci-type spinor
#End Update 8/25/2022

#Update 10/25/2022
#Added number 99: RicciSpinorIrreducibilityAlgorithm, which returns the spinor reducibility structure of a 
#	given Ricci spinor ala Penrose & Rindler Volume II Pg. 276-277.
#	Does NOT however distinguish cases 2 and 3. 
#This also needs the "SegreInvariants" module called
#End Update 10/25/2022

#Update 11/1/2022
#Edited code to remove evalDG where possible.
#Added Yu Invarints and classification module for curvature see (100-102)
#Updated Rank4PsiSpinor to compute properly, had typo.
#Updated 83-88 to be called "Curvature" instead of Alphonse becasue they work most generally for Curvature
#End Update 11/1/2022

#Update 11/3/2022
#Rank3GenerateXiTensor (21) edited. It NEEDS to be an anti-hermitian spinor.
#End Update 11/3/2022

#Update 11/4/2022
#Updated PlebanskiSpinorClassification (98) to return the type instead of print.
#Same for RicciSpinorIrreducibilityAlgorithm (99)
#Also, added CurvatureTensorReducibilityAlgorithm (103) for the complete classification of the curvature tensor
#End Update 11/4/2022

#Update 2/13/2023
#Updated Rank4AlephSpinor & Rank4GenerateAlephTensor to remove the (1/36) &mult from Rank4GenerateAlephTensor
#and add it to Rank4AlephSpinor. We do this to match the notation given in the disseration.
#End Update 2/13/2023

#Update 2/15/2023
#Updated (87) to include a line about antihermiticity in the comments
#in case 7 for (99) RicciSpinorIrreducibilityAlgorithm corrected it to be |(1,0)^2|^2 like Penrose
#We have updated the Yu spinor classification notation to be more clear.
#End Update 2/15/2023


#(*1*)
	ContorsionTensor,
#(*2*)
	MetricAffineConnection,
#(*3*)
	AffineRicciScalar,
#(*4*)
	AffineSpinConnection,
#(*5*)
	FiberedPrimitiveInducedLinearTransformationOnTensors,
#(*6*)
	SpinorHook,
#(*7*)	
	AlphonseTensor,
#(*8*)
	JoshConjugateSpinor,
#(*9*)
	ConstructHermitianSpinor,

#Below on 10-16 are codes to decompose rank 3 tensors into SO(3,1) (signature +,-,-,-.) irreducible spinors.

#(*10*)
	Rank3SSpinor,
#(*11*)
	Rank3OmegaSpinor,
#(*12*)
	Rank3TauSpinor,
#(*13*)
	Rank3PsiSpinor,
#(*14*)
	Rank3XiSpinor,
#(*15*)
	Rank3EtaSpinor,
#(*16*)
	Rank3SigmaSpinor,

#Below on 17-16 are codes to generate rank 3 tensors from a set of SO(3,1) irreducible spinors.

#(*17*)
	Rank3GenerateSTensor,
#(*18*)
	Rank3GenerateOmegaTensor,
#(*19*)
	Rank3GenerateTauTensor,
#(*20*)
	Rank3GeneratePsiTensor,
#(*21*)
	Rank3GenerateXiTensor,
#(*22*)
	Rank3GenerateEtaTensor,
#(*23*)
	Rank3GenerateSigmaTensor,

#Below on 24-26 are codes to Create the SO(N) irreducible representations of the Torsion tensor in tensor form.

#(*24*)
	TorsionTraceQ,
#(*25*)
	TorsionFrankQ,
#(*26*)
	TorsionFrankD,

#Below on 27-29 are codes to Create the SO(3,1) irreducible spinors of the Torsion tensor.

#(*27*)
	TorsionThetaSpinor,
#(*28*)
	TorsionOmegaSpinor,
#(*29*)
	TorsionXiSpinor,

#Below on 30-32 are codes to Create the Torsion tensor from the set of SO(3,1) irreducible spinors that generate it.

#(*30*)
	TorsionGenerateOmegaTensor,
#(*31*)
	TorsionGenerateThetaTensor,
#(*32*)
	TorsionGenerateXiTensor,

#Below on 33-57 are codes to decompose rank 4 tensors into SO(3,1) irreducible spinors.

#Y1 is first:

#(*33*)
	Rank4SSpinor,
#(*34*)
	Rank4IotaSpinor,
#(*35*)
	Rank4UpsilonSpinor,

#Next the Y2's

#Y2a
#(*36*)
	Rank4AlphaSpinor,
#(*37*)
	Rank4OmegaSpinor,
#(*38*)
	Rank4MuSpinor,
#Y2b
#(*39*)
	Rank4BetaSpinor,
#(*40*)
	Rank4KappaSpinor,
#(*41*)
	Rank4RhoSpinor,
#Y2c
#(*42*)
	Rank4GammaSpinor,
#(*43*)
	Rank4ThetaSpinor,
#(*44*)
	Rank4OmicronSpinor,

#Next the Y3's

#Y3a
#(*45*)
	Rank4DeltaSpinor,
#(*46*)
	Rank4PiSpinor,
#(*47*)
	Rank4ChiSpinor,
#Y3b
#(*48*)
	Rank4PsiSpinor,
#(*49*)
	Rank4PhiSpinor,
#(*50*)
	Rank4LambdaSpinor,

#Next the Y4's

#Y4a
#(*51*)
	Rank4TauSpinor,
#(*52*)
	Rank4NuSpinor,
#Y4b
#(*53*)
	Rank4ZetaSpinor,
#(*54*)
	Rank4EtaSpinor,
#Y4c
#(*55*)
	Rank4XiSpinor,
#(*56*)
	Rank4SigmaSpinor,

#Last the Y5:


#(*57*)
	Rank4AlephSpinor,

#Next on 58-82 are codes to construct irreducible tensors from the irreducible Spinors.

#Y1
#(*58*)
	Rank4GenerateSTensor,
#(*59*)
	Rank4GenerateIotaTensor,
#(*60*)
	Rank4GenerateUpsilonTensor,
#Y2

#Y2a
#(*61*)
	Rank4GenerateAlphaTensor,
#(*62*)
	Rank4GenerateOmegaTensor,
#(*63*)
	Rank4GenerateMuTensor,
#Y2b
#(*64*)
	Rank4GenerateBetaTensor,
#(*65*)
	Rank4GenerateKappaTensor,
#(*66*)
	Rank4GenerateRhoTensor,
#Y2c
#(*67*)
	Rank4GenerateGammaTensor,
#(*68*)
	Rank4GenerateThetaTensor,
#(*69*)
	Rank4GenerateOmicronTensor,

#Y3

#Y3a
#(*70*)
	Rank4GenerateDeltaTensor,
#(*71*)
	Rank4GeneratePiTensor,
#(*72*)
	Rank4GenerateChiTensor,
#Y3b
#(*73*)
	Rank4GeneratePsiTensor,
#(*74*)
	Rank4GeneratePhiTensor,
#(*75*)
	Rank4GenerateLambdaTensor,

#Y4

#Y4a
#(*76*)
	Rank4GenerateTauTensor,
#(*77*)
	Rank4GenerateNuTensor,
#Y4b	
#(*78*)
	Rank4GenerateZetaTensor,
#(*79*)
	Rank4GenerateEtaTensor,
#Y4c	
#(*80*)
	Rank4GenerateXiTensor,
#(*81*)
	Rank4GenerateSigmaTensor,

#Y5

#(*82*)
	Rank4GenerateAlephTensor,

#Below on 83-84 are codes to Create the SO(N) irreducible representations of the Curvature tensor in tensor form.
#This is not all of them, as we also have the Curvature Frank K, Frank F, Curly F, and Trace F pieces as well.
#(*83*)
	CurvatureFrankL,
#(*84*)
	CurvatureCurlyL,

#Below on 85-86 are codes to Create the SO(3,1) irreducible spinors of the Curvature tensor.
#This is not all of them, as we also have the Curvature Frank K, Frank F, Curly F, and Trace F pieces as well.	
#(*85*)
	CurvatureZheSpinor,
#(*86*)
	CurvatureYuSpinor,

#Below on 87-88 are codes to Create the Curvature tensor from the set of SO(3,1) irreducible spinors that generate it.
#This is not all of them, as we also have the Curvature Frank K, Frank F, Curly F, and Trace F pieces as well.
#(*87*)
	CurvatureGenerateZheTensor,
#(*88*)
	CurvatureGenerateYuTensor,
#(*89*)
	JoshSolderForm,
#(*90*)
	JoshRaiseLowerSpinorIndices,
#(*91*)
	JoshSpinorInnerProduct,

#Below on 92-94 are codes to decompose rank 2 tensors into SO(3,1) (signature +,-,-,-.) irreducible spinors.

#(*92*)
	Rank2SSpinor,
#(*93*)
	Rank2TauSpinor,
#(*94*)
	Rank2PsiSpinor,

#Below on 95-97 are codes to generate rank 2 tensors from a set of SO(3,1) irreducible spinors.

#(*95*)
	Rank2GenerateSTensor,
#(*96*)
	Rank2GenerateTauTensor,
#(*97*)
	Rank2GeneratePsiTensor,
#(*98*)
	PlebanskiSpinorClassification,
#(*99*)
	RicciSpinorIrreducibilityAlgorithm,
#(*100*)
	CurvatureYuCovariant,
#(*101*)
	CurvatureOmicronInvariant,
#(*102*)
	CurvatureYuReducibilityAlgorithm,
#(*103*)
	CurvatureTensorReducibilityAlgorithm;
#(*104*)
#(*105*)
#(*106*)
#(*107*)
#(*108*)
#(*109*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*1*)

ContorsionTensor:=proc(g,T)
#g is the metric tensor.
#T is the torsion tensor.
local h,T123,T231,T312,KDown,KJosh;

if DGinfo(T, "TensorType")=[["cov_bas", "cov_bas", "cov_bas"], []] then
T123:=T;
T231:=RearrangeIndices(T123,[2,3,1]);
T312:=RearrangeIndices(T123,[3,1,2]);
KDown:=(1/2) &mult (T312 &minus T123 &minus T231);
return KDown;

elif DGinfo(T, "TensorType")=[["con_bas", "cov_bas", "cov_bas"], []] then
h:=InverseMetric(g);
T123:=RaiseLowerIndices(g,T,[1]);
T231:=RearrangeIndices(T123,[2,3,1]);
T312:=RearrangeIndices(T123,[3,1,2]);
KDown:=(1/2) &mult (T312 &minus T123 &minus T231);
KJosh:=RaiseLowerIndices(h,KDown,[1]);
return KJosh;

else
error "expected 2nd argument to be of tensor type [['con_bas', 'cov_bas', 'cov_bas'], []] or [['cov_bas', 'cov_bas', 'cov_bas'], []]. Recieved", DGErrorPrint(o)
fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*2*)

MetricAffineConnection:=proc(g,T,o:="Torsion")
#g is the metric tensor.
#T is the torsion tensor, or the contorsion tensor, see option "o".
local C,Cten,KJosh,GammaJosh;
C:=Christoffel(g);
Cten:=convert(C,DGtensor,[["con_bas","cov_bas","cov_bas"], []]);

if o="Torsion" then

KJosh:=ContorsionTensor(g,T);
GammaJosh:=Connection(Cten + KJosh);
return GammaJosh;

elif o="Contorsion" then

KJosh:=T;
GammaJosh:=Connection(Cten + KJosh);
return GammaJosh;

else 

error "expected 3rd argument be either 'Torsion' or 'Contorsion'. Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*3*)

AffineRicciScalar:=proc(g,T)
local h,GammaJosh,Riemann,Ricci,RicScal,simpRicScal;
h:=InverseMetric(g);
GammaJosh:=MetricAffineConnection(g,T);
Riemann:=CurvatureTensor(GammaJosh);
Ricci:=ContractIndices(Riemann,[[1,3]]);
RicScal:=expand(ContractIndices(h,Ricci,[[1,1],[2,2]]));
simpRicScal:=simplify(RicScal);
return simpRicScal;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*4*)

AffineSpinConnection := proc(Sigma, {torsion:=DGzero["DGtensor"]([["con_bas", "cov_bas", "cov_bas"], []],DGinfo("CurrentFrame"))}, {connectiontype := "total"})
local g, h, Fr, Omega, Sigma1, Sigma2, C1, dSigma, C2, Cspinor, Cbarspinor, C, i, B;
Fr := DGinfo(Sigma,"ObjectFrame");
	if DGinfo(Sigma,"TensorIndexType") <> ["cov_bas", "con_vrt", "con_vrt"] then
			error "expected 1st argument to be a soldering form (a spinor tensor of type [\"cov_bas\", \"con_vrt\", \"con_vrt\"].Received %1", DGErrorPrint(Sigma)
      end if;
g := JoshSpinorInnerProduct(Sigma,Sigma);
	if not g::('DGmetric') then
		error "the  1st argument (solder form) does not determine a non-singular metric"
	end if;
h := InverseMetric(g);
Omega := DGinfo(Fr,"FrameBaseForms");
C := MetricAffineConnection(g,torsion);
Sigma1 := RaiseLowerIndices(h,Sigma,[1]);
Sigma2 := JoshRaiseLowerSpinorIndices(Sigma,[2, 3]);
C1 := RearrangeIndices(ContractIndices(Sigma2,convert(C,DGtensor),[[1, 1]]),[[1, 2, 3]]);
B := DGinfo(Fr,"FrameBaseVectors");
dSigma := evalDG(add(DGmap(2,LieDerivative,Sigma2,B[i]) &t Omega[i],i = 1 .. 4));
C2 := dSigma &minus C1;
Cspinor := ContractIndices(evalDG(1/2*Sigma1),C2,[[1, 1], [3, 3]]);
	if connectiontype = "spinor" then
		return Connection(DGsimplify(Cspinor))
	end if;
Cbarspinor := ContractIndices(evalDG(1/2*Sigma1),C2,[[1, 1], [2, 2]]);
	if connectiontype = "barspinor" then
		return Connection(DGsimplify(Cbarspinor))
	end if;
Connection(DGsimplify(evalDG(Cspinor + Cbarspinor)))
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*5*)

FiberedPrimitiveInducedLinearTransformationOnTensors:=proc(trans,ten)
local A,T,objType,fiberdim,inverse,sol;
A:=trans;
T:=ten;
objType:=DGinfo(T,"ObjectType");
fiberdim:=DGinfo("FrameFiberDimension");
inverse:=MatrixInverse(Matrix([[convert(A,DGMatrix),ZeroMatrix(fiberdim)],[ZeroMatrix(fiberdim),IdentityMatrix(fiberdim)]]));
sol:=PrimitiveInducedLinearTransformationOnTensors:-Main[objType](A,T,('inversematrix') = inverse);
return sol
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*6*)

SpinorHook:=proc(solder,ten)
local soldertype,rank,type,h,solderUp1,solderUp,i,ans;
soldertype:=DGinfo(convert(solder,DGtensor), "TensorIndexType");

###### Comment: Took out this exception to work with orthonormal indices as well
#if soldertype<>["cov_bas", "con_vrt", "con_vrt"] then
#     error "expected solder form to be of type ['cov_bas', 'con_vrt', 'con_vrt']"
#fi;
###### End Comment.

rank:=nops(DGinfo(convert(ten,DGtensor), "TensorIndexType"));
type:=DGinfo(convert(ten,DGtensor), "TensorIndexType");
h:=[];
ans := evalDG(ten);
for i to rank/2 do	
	if type[i]::"con_vrt" or type[i]::"cov_vrt" then
		if type[i]="con_vrt" then
			if h::[] then
				h:=InverseMetric(JoshSpinorInnerProduct(solder,solder));
				solderUp1:=RaiseLowerIndices(h,solder,[1]);
				solderUp:=JoshRaiseLowerSpinorIndices(solderUp1,[2,3]);
			fi;
			ans := ContractIndices(ans,solderUp,[[1,2],[2,3]]);
			i=i+1;
		elif type[i]="cov_vrt" then
			ans := ContractIndices(ans,solder,[[1,2],[2,3]]);
			i=i+1;
		fi;
	fi;
end do;
for i to rank do
	if type[i]::"con_bas" or type[i]::"cov_bas" then
		if type[i]="con_bas" then
			ans := ContractIndices(ans,solder,[[1,1]]);
		elif type[i]="cov_bas" then
			if h::[] then
				h:=InverseMetric(JoshSpinorInnerProduct(solder,solder));
				solderUp1:=RaiseLowerIndices(h,solder,[1]);
				solderUp:=JoshRaiseLowerSpinorIndices(solderUp1,[2,3]);
			fi;
			ans := ContractIndices(ans,solderUp,[[1,1]]);
		fi;
	fi;
od;	
return ans
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*7*)

AlphonseTensor:=proc(g,T)
#g is the metric tensor.
#T is the torsion tensor.
#This computation was derived from ideas in Penrose and Rindler section
#	4.7 Einstein-Cartan-Sciama-Kibble Theory, and other parts of the book. 
local KJosh,C,Kabcd,KCovSymabcd,part1,KKabcd,KKSymabcd,part2,Alphonse;
KJosh:=ContorsionTensor(g,T);
C:=Christoffel(g);
Kabcd:=CovariantDerivative(KJosh,C);
KCovSymabcd:=2 &mult SymmetrizeIndices(Kabcd,[3,4],"SkewSymmetric");
part1:=RearrangeIndices(KCovSymabcd,[1,2,4,3]);
KKabcd:=ContractIndices(evalDG(KJosh &t KJosh),[[2,4]]);
KKSymabcd:=2 &mult SymmetrizeIndices(KKabcd,[2,4],"SkewSymmetric");
part2:=RearrangeIndices(KKSymabcd,[1,3,2,4]);
Alphonse:=part1 &plus part2;
return Alphonse;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*8*)

JoshConjugateSpinor:=proc(aSpinor)
local aSpinorBar,j,i,jList,tensorDimension,sol;
aSpinorBar:=ConjugateSpinor(aSpinor);
tensorDimension:=nops(DGinfo(aSpinor, "TensorType")[1]);
j:=Vector();
j(1):=2;
for i from 2 to tensorDimension do
if type(i,even) then
	j(i):=j(i-1)-1;
else
	j(i):=j(i-1)+3;
fi
od;
jList:=convert(j,list);
sol:=RearrangeIndices(aSpinorBar,jList);
return sol;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*9*)

ConstructHermitianSpinor:=proc(N)
local myTen,mySeq,tau,taubar,equSys,sol,V,A,i,evalSol,assumingSol,myHermitianSpinor;
myTen:=GenerateDGobjects[DGtensors]([seq(op([[dz1,dz2],[dw1,dw2]]),i=1..N)]);
mySeq:=[seq(_a||i,i=1..nops(myTen))];
tau:=DGzip([mySeq],myTen)[1];
taubar:=JoshConjugateSpinor(tau);
equSys:=GetComponents(tau &minus taubar,myTen);
sol:=solve(equSys);
V:=Vector():
A:=Vector():
for i from 1 to nops(myTen) do
if rhs(sol[i])=RootOf(Im(_Z)) then
	V(i):=lhs(sol[i])=lhs(sol[i]);
	A(i):=lhs(sol[i])::real;
else
	V(i):=lhs(sol[i])=rhs(sol[i]);
fi
od;
evalSol:=convert(V,list);
assumingSol:=convert(A,set) minus {0};
myHermitianSpinor:=eval(tau,evalSol);
return assumingSol,myHermitianSpinor
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*10*)

Rank3SSpinor:=proc(B,sigma)
local g,term4,FrankASpinor;
g:=SpinorInnerProduct(sigma,sigma);
term4:=Rank3FrankA(B,g);
FrankASpinor:=SpinorHook(sigma,term4);
return FrankASpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*11*)

Rank3OmegaSpinor:=proc(B,sigma)
local g,epsilon1,epsilon1bar,term1,TraceASpinor,omegaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
term1:=Rank3TraceA(B,g);
TraceASpinor:=SpinorHook(sigma,term1);
omegaSpinor:=ContractIndices(1/6*epsilon1 &t epsilon1bar &t TraceASpinor,[[1,5],[2,7],[3,6],[4,8]]);
return omegaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*12*)

Rank3TauSpinor:=proc(B,sigma)
local g,epsilon1,epsilon1bar,term2,TraceBSpinor,tauSpinor;
g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
term2:=Rank3TraceB(B,g);
TraceBSpinor:=SpinorHook(sigma,term2);
tauSpinor:=ContractIndices(-1/3*epsilon1 &t epsilon1bar &t TraceBSpinor,[[1,5],[2,7],[3,6],[4,8]]);
return tauSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*13*)

Rank3PsiSpinor:=proc(B,sigma)
local g,epsilon1,epsilon1bar,term3,TraceCSpinor,psiSpinor;
g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
term3:=Rank3TraceC(B,g);
TraceCSpinor:=SpinorHook(sigma,term3);
psiSpinor:=ContractIndices(-1/3*epsilon1 &t epsilon1bar &t TraceCSpinor,[[1,5],[2,9],[3,6],[4,10]]);
return psiSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*14*)

Rank3XiSpinor:=proc(B,sigma)
local g,epsilon1,epsilon1bar,term7,FrankDSpinor,XiSpinor;
g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
term7:=Rank3FrankD(B);
FrankDSpinor:=SpinorHook(sigma,term7);
XiSpinor:=RearrangeIndices(ContractIndices(-1/9*epsilon1 &t epsilon1bar &t FrankDSpinor,[[1,5],[2,7],[3,6],[4,10]]),[2,1]);
return XiSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*15*)

Rank3EtaSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term5,FrankBSpinor,etaSpinor,etaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank3FrankB(B,g);
FrankBSpinor:=SpinorHook(sigma,term5);
etaSpinor:=RearrangeIndices(ContractIndices(1/2*epsilon1bar,FrankBSpinor,[[1,2],[2,6]]),[1,2,4,3]);
return etaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
term5:=Rank3FrankB(B,g);
FrankBSpinor:=SpinorHook(sigma,term5);
etaBarSpinor:=RearrangeIndices(ContractIndices(1/2*epsilon1,FrankBSpinor,[[1,1],[2,5]]),[1,4,3,2]);
return etaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*16*)

Rank3SigmaSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term6,FrankCSpinor,sigmaSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term6:=Rank3FrankC(B,g);
FrankCSpinor:=SpinorHook(sigma,term6);
sigmaSpinor:=ContractIndices(1/2*epsilon1bar &t FrankCSpinor,[[1,4],[2,6]]);
return sigmaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
term6:=Rank3FrankC(B,g);
FrankCSpinor:=SpinorHook(sigma,term6);
sigmaSpinor:=RearrangeIndices(ContractIndices(1/2*epsilon1,FrankCSpinor,[[1,1],[2,3]]),[1,2,4,3]);
return sigmaSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*17*)

Rank3GenerateSTensor:=proc(omega,sigma)
local myTensor;
myTensor:=SpinorHook(sigma,omega);
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*18*)

Rank3GenerateOmegaTensor:=proc(omega,sigma)
local epsilon2,epsilon2bar,TASpinorterm1,TASpinorterm2,TASpinorterm3,myTraceASpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
TASpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2 &t epsilon2bar),[1,2,3,5,4,6]);
TASpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t omega &t epsilon2bar),[1,5,3,4,2,6]);
TASpinorterm3:=RearrangeIndices(evalDG(epsilon2 &t epsilon2bar &t omega),[1,3,2,4,5,6]);
myTraceASpinor:=(TASpinorterm1 &plus TASpinorterm2 &plus TASpinorterm3);
myTensor:=SpinorHook(sigma,myTraceASpinor);
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*19*)

Rank3GenerateTauTensor:=proc(tau,sigma)
local epsilon2,epsilon2bar,TBSpinorterm1,TBSpinorterm2,myTraceBSpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
TBSpinorterm1:=RearrangeIndices(evalDG(tau &t epsilon2 &t epsilon2bar),[1,2,3,5,4,6]);
TBSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t epsilon2bar &t tau),[1,3,2,4,5,6]);
myTraceBSpinor:=(TBSpinorterm1 &minus TBSpinorterm2);
myTensor:=SpinorHook(sigma,myTraceBSpinor);
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*20*)

Rank3GeneratePsiTensor:=proc(omega,sigma)
local epsilon2,epsilon2bar,TCSpinorterm1,TCSpinorterm2,myTraceCSpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
TCSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2 &t epsilon2bar),[1,2,3,5,4,6]);
TCSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t omega &t epsilon2bar),[1,5,3,4,2,6]);
myTraceCSpinor:=(TCSpinorterm1 &minus TCSpinorterm2);
myTensor:=SpinorHook(sigma,myTraceCSpinor);
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*21*)

Rank3GenerateXiTensor:=proc(omega,sigma)
local ImaginaryCheck1,ImaginaryCheck2,ImaginaryCheck3,ImaginaryCheck4,ImaginaryCheck5,epsilon2, epsilon2bar, BaseTerm,FDSpinorterm1, FDSpinorterm2,FDSpinorterm3, FDSpinorterm4,FDSpinorterm5,FDSpinorterm6,myFrankDSpinor,myTensor;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
BaseTerm:=RearrangeIndices(evalDG(omega &t epsilon2 &t epsilon2bar),[1,2,3,5,4,6]);
FDSpinorterm1:=RearrangeIndices(BaseTerm,[1,4,3,2,5,6]);
FDSpinorterm2:=RearrangeIndices(BaseTerm,[3,2,1,4,5,6]);
FDSpinorterm3:=RearrangeIndices(BaseTerm,[1,6,3,2,5,4]);
FDSpinorterm4:=RearrangeIndices(BaseTerm,[5,2,1,4,3,6]);
FDSpinorterm5:=RearrangeIndices(BaseTerm,[3,6,1,2,5,4]);
FDSpinorterm6:=RearrangeIndices(BaseTerm,[5,4,1,2,3,6]);
myFrankDSpinor:=FDSpinorterm1 &minus FDSpinorterm2 &plus FDSpinorterm3 &minus FDSpinorterm4 &plus FDSpinorterm5 &minus FDSpinorterm6;
myTensor:=SpinorHook(sigma,myFrankDSpinor);
return myTensor;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*22*)

Rank3GenerateEtaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,etabarSpinor1,etabarSpinor,epsilon2,epsilon2bar,FBSpinorterm1,FBSpinorterm2,myFrankBSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric in the first three indices. Recieved", DGErrorPrint(omega)

else

etabarSpinor1:=ConjugateSpinor(omega);
etabarSpinor:=simplify(etabarSpinor1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FBSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2bar),[1,3,5,4,2,6]);
FBSpinorterm2:=RearrangeIndices(evalDG(etabarSpinor &t epsilon2),[4,2,6,3,1,5]);
myFrankBSpinor:=(FBSpinorterm1 &plus FBSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankBSpinor);
return myTensor;

fi;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2,3],"Symmetric");

	if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first three indices. Recieved", DGErrorPrint(myomegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first three indices. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FBSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2bar),[1,3,5,4,2,6]);
FBSpinorterm2:=RearrangeIndices(evalDG(myomegabar &t epsilon2),[4,2,6,3,1,5]);
myFrankBSpinor:=(FBSpinorterm1 &plus FBSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankBSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*23*)

Rank3GenerateSigmaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,sigmabarSpinor1,sigmabarSpinor,epsilon2,epsilon2bar,FCSpinorterm1,FCSpinorterm2,myFrankCSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric in the first three indices. Recieved", DGErrorPrint(omega)

else

sigmabarSpinor1:=ConjugateSpinor(omega);
sigmabarSpinor:=simplify(sigmabarSpinor1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FCSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2bar),[1,3,5,6,2,4]);
FCSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t sigmabarSpinor),[1,3,2,4,6,5]);
myFrankCSpinor:=(FCSpinorterm1 &plus FCSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankCSpinor);
return myTensor;

fi;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2,3],"Symmetric");

	if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first three indices. Recieved", DGErrorPrint(myomegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first three indices. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FCSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2bar),[1,3,5,6,2,4]);
FCSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t myomegabar),[1,3,2,4,6,5]);
myFrankCSpinor:=(FCSpinorterm1 &plus FCSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankCSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*24*)

TorsionTraceQ:=proc(aTorsionTensor,aMetric)
local SymmetryCheck1,SymmetryCheck2,TraceQ;

SymmetryCheck1:=SymmetrizeIndices(aTorsionTensor,[2,3],"SkewSymmetric");
SymmetryCheck2:=SymmetrizeIndices(aMetric,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,aTorsionTensor)<>true or DGequal(SymmetryCheck2,aMetric)<>true then 

	if DGequal(SymmetryCheck1,aTorsionTensor)<>true then
	
 	error "expected 1st argument be skew symmetric in the last 2 indices. Recieved", DGErrorPrint(aTorsionTensor)

	else

	error "expected 1st argument be a metric tensor. Recieved", DGErrorPrint(aMetric)

fi;

else

TraceQ:=(Rank3TraceB(aTorsionTensor,aMetric) &plus Rank3TraceC(aTorsionTensor,aMetric)):
return TraceQ;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*25*)

TorsionFrankQ:=proc(aTorsionTensor,aMetric)
local SymmetryCheck1,SymmetryCheck2,FrankQ;

SymmetryCheck1:=SymmetrizeIndices(aTorsionTensor,[2,3],"SkewSymmetric");
SymmetryCheck2:=SymmetrizeIndices(aMetric,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,aTorsionTensor)<>true or DGequal(SymmetryCheck2,aMetric)<>true then 

	if DGequal(SymmetryCheck1,aTorsionTensor)<>true then
	
 	error "expected 1st argument be skew symmetric in the last 2 indices. Recieved", DGErrorPrint(aTorsionTensor)

	else

	error "expected 1st argument be a metric tensor. Recieved", DGErrorPrint(aMetric)

fi;

else

FrankQ:=(Rank3FrankB(aTorsionTensor,aMetric) &plus Rank3FrankC(aTorsionTensor,aMetric)):
return FrankQ;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*26*)

TorsionFrankD:=proc(aTorsionTensor,aMetric)
local SymmetryCheck1,SymmetryCheck2,FrankD;

SymmetryCheck1:=SymmetrizeIndices(aTorsionTensor,[2,3],"SkewSymmetric");
SymmetryCheck2:=SymmetrizeIndices(aMetric,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,aTorsionTensor)<>true or DGequal(SymmetryCheck2,aMetric)<>true then 

	if DGequal(SymmetryCheck1,aTorsionTensor)<>true then
	
 	error "expected 1st argument be skew symmetric in the last 2 indices. Recieved", DGErrorPrint(aTorsionTensor)

	else

	error "expected 1st argument be a metric tensor. Recieved", DGErrorPrint(aMetric)

fi;

else

FrankD:=Rank3FrankD(aTorsionTensor):
return FrankD;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*27*)

TorsionThetaSpinor:=proc(aTorsionTensor,aSigma)
local g,TraceQ,TraceQSpinor,epsilon1,epsilon1bar,ThetaSpinor;
g:=SpinorInnerProduct(aSigma,aSigma);
TraceQ:=TorsionTraceQ(aTorsionTensor,g);
TraceQSpinor:=SpinorHook(aSigma,TraceQ);
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
ThetaSpinor:=ContractIndices(-1/3*epsilon1 &t epsilon1bar &t TraceQSpinor,[[1,5],[2,9],[3,6],[4,10]]);
return ThetaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*28*)

TorsionOmegaSpinor:=proc(aTorsionTensor,aSigma,o:= "spinor")
local g,epsilon1,epsilon1bar,FrankQ,FrankQSpinor,OmegaSpinor,OmegaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(aSigma,aSigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
FrankQ:=TorsionFrankQ(aTorsionTensor,g);
FrankQSpinor:=SpinorHook(aSigma,FrankQ);
OmegaSpinor:=RearrangeIndices(ContractIndices(epsilon1bar,FrankQSpinor,[[1,2],[2,6]]),[1,2,4,3]);
return OmegaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(aSigma,aSigma);
epsilon1:=EpsilonSpinor("con","spinor");
FrankQ:=TorsionFrankQ(aTorsionTensor,g);
FrankQSpinor:=SpinorHook(aSigma,FrankQ);
OmegaBarSpinor:=RearrangeIndices(ContractIndices(epsilon1,FrankQSpinor,[[1,1],[2,5]]),[1,4,3,2]);
return OmegaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*29*)

TorsionXiSpinor:=proc(aTorsionTensor,aSigma)
return Rank3XiSpinor(aTorsionTensor,aSigma);
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*30*)

TorsionGenerateThetaTensor:=proc(aThetaSpinor,aSigma,o:="Torsion")
local epsilon2,epsilon2bar,TQSpinorterm1,TQSpinorterm2,myTraceQSpinor,sol;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");

if o="Torsion" then

TQSpinorterm1:=RearrangeIndices(evalDG(epsilon2 &t aThetaSpinor &t epsilon2bar),[1,3,5,6,2,4]);
TQSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t aThetaSpinor &t epsilon2bar),[1,5,3,4,2,6]);
myTraceQSpinor:=(TQSpinorterm1 &minus TQSpinorterm2);
sol:=SpinorHook(aSigma,myTraceQSpinor);
return sol;

elif o="Contorsion" then

TQSpinorterm1:=RearrangeIndices(evalDG(epsilon2 &t aThetaSpinor &t epsilon2bar),[1,3,5,6,2,4]);
TQSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t aThetaSpinor &t epsilon2bar),[1,5,3,4,2,6]);
myTraceQSpinor:=(TQSpinorterm2 &minus TQSpinorterm1);
sol:=SpinorHook(aSigma,myTraceQSpinor);
return sol;

else 

error "expected 3rd argument be either 'Torsion' or 'Contorsion'. Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*31*)

TorsionGenerateOmegaTensor:=proc(aOmegaSpinor,aSigma,myomegabar:=0,o:="Torsion")
local SymmetryCheck1,SymmetryCheck2,OmegabarSpinor1,OmegabarSpinor,epsilon2,epsilon2bar,FQSpinorterm1,FQSpinorterm2,myFrankQSpinor,myTensor,KFQSpinorterm1,KFQSpinorterm2;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(aOmegaSpinor,[1,2,3],"Symmetric");

if DGequal(SymmetryCheck1,aOmegaSpinor)<>true then 

error "expected 1st argument be totally symmetric in the first three indices. Recieved", DGErrorPrint(omega)

else

OmegabarSpinor1:=ConjugateSpinor(aOmegaSpinor);
OmegabarSpinor:=simplify(OmegabarSpinor1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");

if o="Torsion" then

FQSpinorterm1:=RearrangeIndices(evalDG(aOmegaSpinor &t epsilon2bar),[1,3,5,2,4,6]);
FQSpinorterm2:=RearrangeIndices(evalDG(OmegabarSpinor &t epsilon2),[2,4,6,1,3,5]);
myFrankQSpinor:=(FQSpinorterm1 &plus FQSpinorterm2);
myTensor:=SpinorHook(aSigma,myFrankQSpinor);
return myTensor;

elif o="Contorsion" then

KFQSpinorterm1:=RearrangeIndices(evalDG(myOmegaSpinor &t epsilon2bar),[1,3,5,6,2,4]):
KFQSpinorterm2:=RearrangeIndices(evalDG(myOmegaBarSpinor &t epsilon2),[2,4,6,5,1,3]):
myFrankQSpinor:=(KFQSpinorterm1 &plus KFQSpinorterm2);
myTensor:=SpinorHook(aSigma,myFrankQSpinor);
return myTensor;

else

error "expected 3rd argument be either 'Torsion' or 'Contorsion'. Recieved", DGErrorPrint(o)

fi;
fi;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2,3],"Symmetric");

	if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first three indices. Recieved", DGErrorPrint(myomegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(aOmegaSpinor,[1,2,3],"Symmetric");

	if DGequal(SymmetryCheck1,aOmegaSpinor)<>true then 

error "expected 1st argument be symmetric in the first three indices. Recieved", DGErrorPrint(aOmegaSpinor)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");

if o="Torsion" then

FQSpinorterm1:=RearrangeIndices(evalDG(aOmegaSpinor &t epsilon2bar),[1,3,5,2,4,6]);
FQSpinorterm2:=RearrangeIndices(evalDG(myomegabar &t epsilon2),[2,4,6,1,3,5]);
myFrankQSpinor:=(FQSpinorterm1 &plus FQSpinorterm2);
myTensor:=SpinorHook(aSigma,myFrankQSpinor);
return myTensor;

elif o="Contorsion" then

KFQSpinorterm1:=RearrangeIndices(evalDG(myOmegaSpinor &t epsilon2bar),[1,3,5,6,2,4]):
KFQSpinorterm2:=RearrangeIndices(evalDG(myomegabar &t epsilon2),[2,4,6,5,1,3]):
myFrankQSpinor:=(KFQSpinorterm1 &plus KFQSpinorterm2);
myTensor:=SpinorHook(aSigma,myFrankQSpinor);
return myTensor;

else

error "expected 3rd argument be either 'Torsion' or 'Contorsion'. Recieved", DGErrorPrint(o)

fi;
fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*32*)

TorsionGenerateXiTensor:=proc(aXiSpinor,aSigma,o:="Torsion")
local t;

if o="Torsion" then
return Rank3GenerateXiTensor(aXiSpinor,aSigma);

elif o="Contorsion" then
t:=(-1/2) &mult Rank3GenerateXiTensor(aXiSpinor,aSigma);
return t;

else
error "expected 3rd argument be either 'Torsion' or 'Contorsion'. Recieved", DGErrorPrint(o)

fi;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*33*)

Rank4SSpinor:=proc(T,sigma)
local g,FrankA,FrankASpinor;
g:=SpinorInnerProduct(sigma,sigma);
FrankA:=Rank4FrankA(T,g);
FrankASpinor:=SpinorHook(sigma,FrankA);
return FrankASpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*34*)

Rank4IotaSpinor:=proc(T,sigma)
local g,h,N,Y1,S1,Ptensor,Pscalar,PtraceFree,iotaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y1:=op(YoungTableauBasis([4], [1,2,3,4], output = "Matrix"));
S1:=YoungSymmetrizer(T,Y1);
Ptensor:=ContractIndices(h,S1,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
PtraceFree:=(Ptensor &minus ((1/N*Pscalar) &mult g));
iotaSpinor:=(1/8) &mult SpinorHook(sigma,PtraceFree);
return iotaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*35*)

Rank4UpsilonSpinor:=proc(T,sigma)
local g,h,N,Y1,S1,Ptensor,Pscalar,upsilonSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y1:=op(YoungTableauBasis([4], [1,2,3,4], output = "Matrix"));
S1:=YoungSymmetrizer(T,Y1);
Ptensor:=ContractIndices(h,S1,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
upsilonSpinor:=1/24*Pscalar;
return upsilonSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*36*)

Rank4AlphaSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1bar,term5,FrankBSpinor,alphaSpinor1,alphaSpinor,alphaBarSpinor1,alphaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank4FrankB(B,g);
FrankBSpinor:=SpinorHook(sigma,term5);
alphaSpinor1:=ContractIndices(epsilon1bar,FrankBSpinor,[[1,2],[2,8]]);
alphaSpinor:=(1/2) &mult RearrangeIndices(alphaSpinor1,[1,2,5,3,6,4]);
return alphaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank4FrankB(B,g);
FrankBSpinor:=SpinorHook(sigma,term5);
alphaBarSpinor1:=ContractIndices(epsilon1,FrankBSpinor,[[1,1],[2,7]]):
alphaBarSpinor:=(1/2) &mult RearrangeIndices(alphaBarSpinor1,[1,5,2,6,3,4]):
return alphaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*37*)

Rank4OmegaSpinor:=proc(T,sigma)
local g,h,N,Y2a,S2,Ptensor,SymP,UpsilonTensorSym,OmegaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y2a:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[1];
S2:=YoungSymmetrizer(T,Y2a);
Ptensor:=ContractIndices(h,S2,[[1,1],[2,2]]);
SymP:=SymmetrizeIndices(Ptensor,[1,2],"Symmetric");
UpsilonTensorSym:=evalDG(1/N*SymP);
OmegaSpinor:=SpinorHook(sigma,UpsilonTensorSym);
return OmegaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*38*)

Rank4MuSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1,epsilon1bar,Y2a,S2,Ptensor,SkewP,UpsilonTensorSkew,muSpinor1,muSpinor,muBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
Y2a:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[1];
S2:=YoungSymmetrizer(B,Y2a);
Ptensor:=ContractIndices(h,S2,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric"):
UpsilonTensorSkew:=evalDG(1/2/(N+2)*SkewP):
muSpinor1:=SpinorHook(sigma,UpsilonTensorSkew):
muSpinor:=ContractIndices(epsilon1bar,muSpinor1,[[1,2],[2,4]]):
return muSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
Y2a:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[1];
S2:=YoungSymmetrizer(B,Y2a);
Ptensor:=ContractIndices(h,S2,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric"):
UpsilonTensorSkew:=evalDG(1/2/(N+2)*SkewP):
muSpinor1:=SpinorHook(sigma,UpsilonTensorSkew):
muBarSpinor:=ContractIndices(epsilon1,muSpinor1,[[1,1],[2,3]]):
return muBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*39*)

Rank4BetaSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term5,FrankCSpinor,betaSpinor1,betaSpinor,betaBarSpinor1,betaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank4FrankC(B,g);
FrankCSpinor:=SpinorHook(sigma,term5);
betaSpinor1:=ContractIndices(epsilon1bar,FrankCSpinor,[[1,2],[2,6]]);
betaSpinor:=(1/2) &mult RearrangeIndices(betaSpinor1,[1,2,5,3,4,6]);
return betaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
term5:=Rank4FrankC(B,g);
FrankCSpinor:=SpinorHook(sigma,term5);
betaBarSpinor1:=ContractIndices(epsilon1,FrankCSpinor,[[1,1],[2,5]]):
betaBarSpinor:=(1/2) &mult RearrangeIndices(betaBarSpinor1,[1,5,2,3,6,4]):
return betaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*40*)

Rank4KappaSpinor:=proc(T,sigma)
local g,h,N,Y2b,S3,Ptensor,SymP,UpsilonTensorSym,KappaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y2b:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[2];
S3:=YoungSymmetrizer(T,Y2b);
Ptensor:=ContractIndices(h,S3,[[1,1],[2,2]]);
SymP:=SymmetrizeIndices(Ptensor,[1,2],"Symmetric");
UpsilonTensorSym:=evalDG(1/N*SymP);
KappaSpinor:=SpinorHook(sigma,UpsilonTensorSym);
return KappaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*41*)

Rank4RhoSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1,epsilon1bar,Y2b,S3,Ptensor,SkewP,UpsilonTensorSkew,rhoSpinor1,rhoSpinor,rhoBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
Y2b:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[2];
S3:=YoungSymmetrizer(T,Y2b);
Ptensor:=ContractIndices(h,S3,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric");
UpsilonTensorSkew:=evalDG(1/2/(N+2)*SkewP);
rhoSpinor1:=SpinorHook(sigma,UpsilonTensorSkew);
rhoSpinor:=ContractIndices(epsilon1bar,rhoSpinor1,[[1,2],[2,4]]);
return rhoSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
Y2b:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[2];
S3:=YoungSymmetrizer(T,Y2b);
Ptensor:=ContractIndices(h,S3,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric");
UpsilonTensorSkew:=evalDG(1/2/(N+2)*SkewP);
rhoSpinor1:=SpinorHook(sigma,UpsilonTensorSkew);
rhoBarSpinor:=ContractIndices(epsilon1,rhoSpinor1,[[1,1],[2,3]]):
return rhoBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*42*)

Rank4GammaSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term5,FrankDSpinor,gammaSpinor1,gammaSpinor,gammaBarSpinor1,gammaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank4FrankD(B,g);
FrankDSpinor:=SpinorHook(sigma,term5);
gammaSpinor1:=ContractIndices(epsilon1bar,FrankDSpinor,[[1,2],[2,4]]);
gammaSpinor:=(1/2) &mult RearrangeIndices(gammaSpinor1,[1,2,3,5,4,6]);
return gammaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
term5:=Rank4FrankD(B,g);
FrankDSpinor:=SpinorHook(sigma,term5);
gammaBarSpinor1:=ContractIndices(epsilon1,FrankDSpinor,[[1,1],[2,3]]):
gammaBarSpinor:=(1/2) &mult RearrangeIndices(gammaBarSpinor1,[1,2,5,3,6,4]):
return gammaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*43*)

Rank4ThetaSpinor:=proc(T,sigma)
local g,h,N,Y2c,S4,Rtensor,SymR,UpsilonTensorSym,ThetaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y2c:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[3];
S4:=YoungSymmetrizer(T,Y2c);
Rtensor:=ContractIndices(h,S4,[[1,1],[2,3]]);
SymR:=SymmetrizeIndices(Rtensor,[1,2],"Symmetric");
UpsilonTensorSym:=evalDG(1/N*SymR);
ThetaSpinor:=SpinorHook(sigma,UpsilonTensorSym);
return ThetaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*44*)

Rank4OmicronSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1,epsilon1bar,Y2c,S4,Rtensor,SkewR,UpsilonTensorSkew,omicronSpinor1,omicronSpinor,omicronBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
Y2c:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[3];
S4:=YoungSymmetrizer(T,Y2c):
Rtensor:=ContractIndices(h,S4,[[1,1],[2,3]]):
SkewR:=SymmetrizeIndices(Rtensor,[1,2],"SkewSymmetric"):
UpsilonTensorSkew:=evalDG(1/2/(N+2)*SkewR):
omicronSpinor1:=SpinorHook(sigma,UpsilonTensorSkew):
omicronSpinor:=ContractIndices(epsilon1bar,omicronSpinor1,[[1,2],[2,4]]):
return omicronSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
Y2c:=YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix")[3];
S4:=YoungSymmetrizer(T,Y2c):
Rtensor:=ContractIndices(h,S4,[[1,1],[2,3]]):
SkewR:=SymmetrizeIndices(Rtensor,[1,2],"SkewSymmetric"):
UpsilonTensorSkew:=evalDG(1/2/(N+2)*SkewR):
omicronSpinor1:=SpinorHook(sigma,UpsilonTensorSkew):
omicronBarSpinor:=ContractIndices(epsilon1,omicronSpinor1,[[1,1],[2,3]]):
return omicronBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*45*)

Rank4DeltaSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term5,FrankESpinor,deltaSpinor,deltaBarSpinor;
if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank4FrankE(B,g);
FrankESpinor:=SpinorHook(sigma,term5);
deltaSpinor:=(1/4) &mult ContractIndices(evalDG(epsilon1bar &t epsilon1bar),FrankESpinor,[[1,2],[2,6],[3,4],[4,8]]);
return deltaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
term5:=Rank4FrankE(B,g);
FrankESpinor:=SpinorHook(sigma,term5);
deltaBarSpinor:=(1/4) &mult ContractIndices(evalDG(epsilon1 &t epsilon1),FrankESpinor,[[1,1],[2,5],[3,3],[4,7]]):
return deltaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*46*)

Rank4PiSpinor:=proc(T,sigma)
local g,h,N,Y3a,S5,Ptensor,Pscalar,PtraceFree,piSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y3a:=YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix")[1];
S5:=YoungSymmetrizer(T,Y3a);
Ptensor:=ContractIndices(h,S5,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
PtraceFree:=(Ptensor &minus ((1/N*Pscalar) &mult g));
piSpinor:=(1/2) &mult SpinorHook(sigma,PtraceFree):
return piSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*47*)

Rank4ChiSpinor:=proc(T,sigma)
local g,h,N,Y3a,S5,Ptensor,Pscalar,chiSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y3a:=YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix")[1];
S5:=YoungSymmetrizer(T,Y3a):
Ptensor:=ContractIndices(h,S5,[[1,1],[2,2]]):
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]):
chiSpinor:=1/12*Pscalar:
return chiSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*48*)

Rank4PsiSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term5,FrankFSpinor,PsiSpinor,PsiBarSpinor;
if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1bar:=EpsilonSpinor("con","barspinor");
term5:=Rank4FrankF(B,g);
FrankFSpinor:=SpinorHook(sigma,term5):
PsiSpinor:=(1/4) &mult ContractIndices(evalDG(epsilon1bar &t epsilon1bar),FrankFSpinor,[[1,2],[2,4],[3,6],[4,8]]);
return PsiSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
epsilon1:=EpsilonSpinor("con","spinor");
term5:=Rank4FrankF(B,g);
FrankFSpinor:=SpinorHook(sigma,term5):
PsiBarSpinor:=(1/4) &mult ContractIndices(evalDG(epsilon1 &t epsilon1),FrankFSpinor,[[1,1],[2,3],[3,5],[4,7]]):
return PsiBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*49*)

Rank4PhiSpinor:=proc(T,sigma)
local g,h,N,Y3b,S6,Rtensor,Rscalar,RtraceFree,PhiSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y3b:=YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix")[2];
S6:=YoungSymmetrizer(T,Y3b);
Rtensor:=ContractIndices(h,S6,[[1,1],[2,3]]):
Rscalar:=ContractIndices(h,Rtensor,[[1,1],[2,2]]):
RtraceFree:=(Rtensor &minus ((1/N*Rscalar) &mult g)):
PhiSpinor:=(1/2) &mult SpinorHook(sigma,RtraceFree):
return PhiSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*50*)

Rank4LambdaSpinor:=proc(T,sigma)
local g,h,N,Y3b,S6,Rtensor,Rscalar,LambdaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
Y3b:=YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix")[2];
S6:=YoungSymmetrizer(T,Y3b):
Rtensor:=ContractIndices(h,S6,[[1,1],[2,3]]):
Rscalar:=ContractIndices(h,Rtensor,[[1,1],[2,2]]):
LambdaSpinor:=1/12*Rscalar:
return LambdaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*51*)

Rank4TauSpinor:=proc(T,sigma)
local g,h,N,FrankG,FrankGSpinor,epsilon1,epsilon1bar,tauSpinor;
g:=SpinorInnerProduct(sigma,sigma);
FrankG:=Rank4FrankG(T,g):
FrankGSpinor:=SpinorHook(sigma,FrankG):
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
tauSpinor:=(1/2) &mult ContractIndices(epsilon1 &t epsilon1bar,FrankGSpinor,[[1,1],[2,5],[3,2],[4,4]]):
return tauSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*52*)

Rank4NuSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1,epsilon1bar,Y4a,S7,Ptensor,Pspinor,nuSpinor,nuBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
Y4a:=YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix")[1]:
S7:=YoungSymmetrizer(B,Y4a):
Ptensor:=ContractIndices(h,S7,[[1,1],[2,2]]):
Pspinor:=SpinorHook(sigma,Ptensor):
nuSpinor:=(1/4) &mult ContractIndices(epsilon1bar,Pspinor,[[1,2],[2,4]]):
return nuSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
Y4a:=YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix")[1]:
S7:=YoungSymmetrizer(B,Y4a):
Ptensor:=ContractIndices(h,S7,[[1,1],[2,2]]):
Pspinor:=SpinorHook(sigma,Ptensor):
nuBarSpinor:=(1/4) &mult ContractIndices(epsilon1,Pspinor,[[1,1],[2,3]]):
return nuBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*53*)

Rank4ZetaSpinor:=proc(T,sigma)
local g,h,N,FrankH,FrankHSpinor,epsilon1,epsilon1bar,zetaSpinor;
g:=SpinorInnerProduct(sigma,sigma);
FrankH:=Rank4FrankH(T,g):
FrankHSpinor:=SpinorHook(sigma,FrankH):
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
zetaSpinor:=(1/2) &mult ContractIndices(epsilon1 &t epsilon1bar,FrankHSpinor,[[1,1],[2,5],[3,2],[4,4]]):
return zetaSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*54*)

Rank4EtaSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1,epsilon1bar,Y4b,S8,Rtensor,Rspinor,etaSpinor,etaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
Y4b:=YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix")[2]:
S8:=YoungSymmetrizer(B,Y4b):
Rtensor:=ContractIndices(h,S8,[[1,1],[2,3]]):
Rspinor:=SpinorHook(sigma,Rtensor):
etaSpinor:=(1/4) &mult ContractIndices(epsilon1bar,Rspinor,[[1,2],[2,4]]):
return etaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
Y4b:=YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix")[2]:
S8:=YoungSymmetrizer(B,Y4b):
Rtensor:=ContractIndices(h,S8,[[1,1],[2,3]]):
Rspinor:=SpinorHook(sigma,Rtensor):
etaBarSpinor:=(1/4) &mult ContractIndices(epsilon1,Rspinor,[[1,1],[2,3]]):
return etaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*55*)

Rank4XiSpinor:=proc(T,sigma)
local g,h,N,FrankJ,FrankJSpinor,epsilon1,epsilon1bar,xiSpinor;
g:=SpinorInnerProduct(sigma,sigma);
FrankJ:=Rank4FrankJ(T,g):
FrankJSpinor:=SpinorHook(sigma,FrankJ):
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
xiSpinor:=(-1/4) &mult RearrangeIndices(ContractIndices(epsilon1 &t epsilon1bar,FrankJSpinor,[[1,3],[2,5],[3,2],[4,8]]),[1,2,4,3]):
return xiSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*56*)

Rank4SigmaSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1,epsilon1bar,Y4c,S9,Utensor,Uspinor,sigmaSpinor,sigmaBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
Y4c:=YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix")[3]:
S9:=YoungSymmetrizer(B,Y4c):
Utensor:=ContractIndices(h,S9,[[1,1],[2,4]]):
Uspinor:=SpinorHook(sigma,Utensor):
sigmaSpinor:=(1/4) &mult ContractIndices(epsilon1bar,Uspinor,[[1,2],[2,4]]):
return sigmaSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
Y4c:=YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix")[3]:
S9:=YoungSymmetrizer(B,Y4c):
Utensor:=ContractIndices(h,S9,[[1,1],[2,4]]):
Uspinor:=SpinorHook(sigma,Utensor):
sigmaBarSpinor:=(1/4) &mult ContractIndices(epsilon1,Uspinor,[[1,1],[2,3]]):
return sigmaBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*57*)

Rank4AlephSpinor:=proc(T,sigma)
local g,h,N,FrankK,FrankKSpinor,epsilon1,epsilon1bar,alephSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
FrankK:=Rank4FrankK(T,g):
FrankKSpinor:=SpinorHook(sigma,FrankK):
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
alephSpinor:=(1/36) &mult ContractIndices(epsilon1 &t epsilon1bar &t epsilon1 &t epsilon1bar,FrankKSpinor,[[1,1],[2,3],[3,2],[4,6],[5,5],[6,7],[7,4],[8,8]]);
return alephSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*58*)

Rank4GenerateSTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3,5,7],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4,6,8],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first odd four indices, and the last even four indices seperately. Recieved", DGErrorPrint(omega)

else

myTensor:=SpinorHook(sigma,omega);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*59*)

Rank4GenerateIotaTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,term5,term6,myCurlyASpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega);
term1:=RearrangeIndices(baseterm,[1,3,2,4,5,6,7,8]);
term2:=RearrangeIndices(baseterm,[1,5,2,6,3,4,7,8]);
term3:=RearrangeIndices(baseterm,[1,7,2,8,3,4,5,6]);
term4:=RearrangeIndices(baseterm,[3,5,4,6,1,2,7,8]);
term5:=RearrangeIndices(baseterm,[3,7,4,8,1,2,5,6]);
term6:=RearrangeIndices(baseterm,[5,7,6,8,1,2,3,4]);
myCurlyASpinor:=(term1 &plus term2 &plus term3 &plus term4 &plus term5 &plus term6);
myTensor:=SpinorHook(sigma,myCurlyASpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*60*)

Rank4GenerateUpsilonTensor:=proc(omega,sigma)
local epsilon2,epsilon2bar,baseterm,term1,term2,term3,myTraceASpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t epsilon2 &t epsilon2bar * upsilonSpinor):
term1:=RearrangeIndices(baseterm,[1,3,2,4,5,7,6,8]):
term2:=RearrangeIndices(baseterm,[1,5,2,6,3,7,4,8]):
term3:=RearrangeIndices(baseterm,[1,7,2,8,5,3,6,4]):
myTraceASpinor:=(term1 &plus term2 &plus term3):
myTensor:=SpinorHook(sigma,myTraceASpinor):
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*61*)

Rank4GenerateAlphaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,SymmetryCheck3,SymmetryCheck4,omegabar1,omegabar,epsilon2,epsilon2bar,FBSpinorterm1,FBSpinorterm2,myFrankBSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[5,6],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

	fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FBSpinorterm1:=RearrangeIndices(epsilon2 &t omegabar,[1,7,2,8,4,6,3,5]);
FBSpinorterm2:=RearrangeIndices(epsilon2bar &t omega,[2,8,1,7,3,5,4,6]);
myFrankBSpinor:=(FBSpinorterm1 &plus FBSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankBSpinor);
return myTensor;

###Case when omegabar is given###

else

SymmetryCheck3:=SymmetrizeIndices(myomegabar,[1,2,3,4],"Symmetric");
SymmetryCheck4:=SymmetrizeIndices(myomegabar,[5,6],"Symmetric");

	if DGequal(SymmetryCheck3,myomegabar)<>true or DGequal(SymmetryCheck4,myomegabar)<>true then 

error "expected 3rd argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[5,6],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FBSpinorterm1:=RearrangeIndices(epsilon2 &t myomegabar,[1,7,2,8,4,6,3,5]);
FBSpinorterm2:=RearrangeIndices(epsilon2bar &t omega,[2,8,1,7,3,5,4,6]);
myFrankBSpinor:=(FBSpinorterm1 &plus FBSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankBSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*62*)

Rank4GenerateOmegaTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,term5,term6,myHebrewBSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega);
term1:=RearrangeIndices(baseterm,[1,3,2,4,5,6,7,8]);
term2:=RearrangeIndices(baseterm,[1,5,2,6,3,4,7,8]);
term3:=RearrangeIndices(baseterm,[7,3,8,4,5,6,1,2]);
term4:=RearrangeIndices(baseterm,[7,5,8,6,3,4,1,2]);
myHebrewBSpinor:=(term1 &plus term2 &minus term3 &minus term4);
myTensor:=SpinorHook(sigma,myHebrewBSpinor);
return myTensor;
fi;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*63*)

Rank4GenerateMuTensor:=proc(omega,sigma)
local SymmetryCheck1,omegabar1,omegabar,epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,term5,myCyrillicBSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

else

omegabar1:=ConjugateSpinor(omega);
#We can assume real here because the tensor is determined by the real part of this spinor anyway :)
omegabar:=simplify(omegabar1) assuming real;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2bar &t epsilon2 &t (epsilon2bar &t omega + omegabar &t epsilon2)):
term1:=RearrangeIndices(baseterm,[2,4,1,3,6,8,5,7]):
term2:=RearrangeIndices(baseterm,[4,6,3,5,2,8,1,7]):
term3:=RearrangeIndices(baseterm,[2,6,1,5,4,8,3,7]):
term4:=RearrangeIndices(baseterm,[4,8,3,7,2,6,1,5]):
term5:=RearrangeIndices(baseterm,[6,8,5,7,2,4,1,3]):
myCyrillicBSpinor:=(term1 &plus (2 &mult term2) &plus term3 &plus term4 &plus term5):
myTensor:=SpinorHook(sigma,myCyrillicBSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*64*)

Rank4GenerateBetaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,SymmetryCheck3,SymmetryCheck4,omegabar1,omegabar,epsilon2,epsilon2bar,FCSpinorterm1,FCSpinorterm2,myFrankCSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[5,6],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

	fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FCSpinorterm1:=RearrangeIndices(epsilon2 &t omegabar,[1,5,2,4,6,8,3,7]):
FCSpinorterm2:=RearrangeIndices(epsilon2bar &t omega,[2,6,1,5,3,7,4,8]);
myFrankCSpinor:=(FCSpinorterm1 &plus FCSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankCSpinor);
return myTensor;

###Case when omegabar is given###

else

SymmetryCheck3:=SymmetrizeIndices(myomegabar,[1,2,3,4],"Symmetric");
SymmetryCheck4:=SymmetrizeIndices(myomegabar,[5,6],"Symmetric");

	if DGequal(SymmetryCheck3,myomegabar)<>true or DGequal(SymmetryCheck4,myomegabar)<>true then 

error "expected 3rd argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[5,6],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FCSpinorterm1:=RearrangeIndices(epsilon2 &t myomegabar,[1,5,2,4,6,8,3,7]):
FCSpinorterm2:=RearrangeIndices(epsilon2bar &t omega,[2,6,1,5,3,7,4,8]);
myFrankCSpinor:=(FCSpinorterm1 &plus FCSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankCSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*65*)

Rank4GenerateKappaTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,term5,term6,myHebrewCSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega);
term1:=RearrangeIndices(baseterm,[1,3,2,4,5,6,7,8]);
term2:=RearrangeIndices(baseterm,[1,7,2,8,5,6,3,4]);
term3:=RearrangeIndices(baseterm,[5,3,6,4,1,2,7,8]);
term4:=RearrangeIndices(baseterm,[5,7,6,8,1,2,3,4]);
myHebrewCSpinor:=(term1 &plus term2 &minus term3 &minus term4);
myTensor:=SpinorHook(sigma,myHebrewCSpinor);
return myTensor;
fi;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*66*)

Rank4GenerateRhoTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,mySkewP,g,term1,term2,term3,term4,term5,myCyrillicCTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
mySkewP:=(6) &mult SpinorHook(sigma,RearrangeIndices(evalDG(omega &t epsilon2bar+epsilon2 &t omegabar),[1,3,2,4])):
g:=SpinorInnerProduct(sigma,sigma);
term2:=evalDG(g &t mySkewP):
term1:=RearrangeIndices(term2,[2,4,1,3]):
term3:=RearrangeIndices(term2,[1,4,2,3]):
term4:=RearrangeIndices(term2,[2,3,1,4]):
term5:=RearrangeIndices(term2,[3,4,1,2]):
myCyrillicCTensor:=(1/6) &mult ((-2) &mult term1 &plus term2 &minus term3 &minus term4 &minus term5):
return myCyrillicCTensor;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
mySkewP:=(6) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar) &plus (epsilon2 &tensor myomegabar)),[1,3,2,4])):
g:=SpinorInnerProduct(sigma,sigma);
term2:=evalDG(g &t mySkewP):
term1:=RearrangeIndices(term2,[2,4,1,3]):
term3:=RearrangeIndices(term2,[1,4,2,3]):
term4:=RearrangeIndices(term2,[2,3,1,4]):
term5:=RearrangeIndices(term2,[3,4,1,2]):
myCyrillicCTensor:=(1/6) &mult ((-2) &mult term1 &plus term2 &minus term3 &minus term4 &minus term5):
return myCyrillicCTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*67*)

Rank4GenerateGammaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,SymmetryCheck3,SymmetryCheck4,omegabar1,omegabar,epsilon2,epsilon2bar,FDSpinorterm1,FDSpinorterm2,myFrankDSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[5,6],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

	fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FDSpinorterm1:=RearrangeIndices(epsilon2 &t omegabar,[1,3,2,4,6,8,5,7]);
FDSpinorterm2:=RearrangeIndices(epsilon2bar &t omega,[2,4,1,3,5,7,6,8]);
myFrankDSpinor:=(FDSpinorterm1 &plus FDSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankDSpinor);
return myTensor;

###Case when omegabar is given###

else

SymmetryCheck3:=SymmetrizeIndices(myomegabar,[1,2,3,4],"Symmetric");
SymmetryCheck4:=SymmetrizeIndices(myomegabar,[5,6],"Symmetric");

	if DGequal(SymmetryCheck3,myomegabar)<>true or DGequal(SymmetryCheck4,myomegabar)<>true then 

error "expected 3rd argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[5,6],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be totally symmetric in the first four indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FDSpinorterm1:=RearrangeIndices(epsilon2 &t myomegabar,[1,3,2,4,6,8,5,7]);
FDSpinorterm2:=RearrangeIndices(epsilon2bar &t omega,[2,4,1,3,5,7,6,8]);
myFrankDSpinor:=(FDSpinorterm1 &plus FDSpinorterm2);
myTensor:=SpinorHook(sigma,myFrankDSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*68*)

Rank4GenerateThetaTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,term5,term6,myHebrewDSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega);
term1:=RearrangeIndices(baseterm,[1,5,2,6,3,4,7,8]);
term2:=RearrangeIndices(baseterm,[1,7,2,8,3,4,5,6]);
term3:=RearrangeIndices(baseterm,[3,5,4,6,1,2,7,8]);
term4:=RearrangeIndices(baseterm,[3,7,4,8,1,2,5,6]);
myHebrewDSpinor:=(term1 &plus term2 &minus term3 &minus term4);
myTensor:=SpinorHook(sigma,myHebrewDSpinor);
return myTensor;
fi;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*69*)

Rank4GenerateOmicronTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,g,mySkewR,term1,term2,term3,term4,term5,myCyrillicD;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
mySkewR:=SpinorHook(sigma,RearrangeIndices((6) &mult ((omega &tensor epsilon2bar) &plus (epsilon2 &tensor omegabar)),[1,3,2,4]));
g:=SpinorInnerProduct(sigma,sigma);
term1:=evalDG(mySkewR &t g);
term2:=RearrangeIndices(term1,[3,1,2,4]);
term3:=RearrangeIndices(term1,[3,2,1,4]);
term4:=RearrangeIndices(term1,[4,1,2,3]);
term5:=RearrangeIndices(term1,[4,2,1,3]);
myCyrillicD:=(1/6) &mult ((-2) &mult term1 &plus term2 &minus term3 &plus term4 &minus term5);
return myCyrillicD;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
mySkewR:=SpinorHook(sigma,RearrangeIndices((6) &mult ((omega &tensor epsilon2bar)  &plus  (epsilon2 &tensor myomegabar)),[1,3,2,4]));
g:=SpinorInnerProduct(sigma,sigma);
term1:=evalDG(mySkewR &t g);
term2:=RearrangeIndices(term1,[3,1,2,4]);
term3:=RearrangeIndices(term1,[3,2,1,4]);
term4:=RearrangeIndices(term1,[4,1,2,3]);
term5:=RearrangeIndices(term1,[4,2,1,3]);
myCyrillicD:=(1/6) &mult ((-2) &mult term1 &plus term2 &minus term3 &plus term4 &minus term5);
return myCyrillicD;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*70*)

Rank4GenerateDeltaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,term1,term2,term3,term4,myFrankESpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric. Recieved", DGErrorPrint(omega)

	fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=evalDG(omega &t epsilon2bar &t epsilon2bar):
term2:=evalDG(epsilon2 &t epsilon2 &t omegabar):
term3:=RearrangeIndices(term1,[1,3,5,7,2,6,4,8]):
term4:=RearrangeIndices(term2,[1,5,3,7,2,4,6,8]):
myFrankESpinor:=(term3 &plus term4):
myTensor:=SpinorHook(sigma,myFrankESpinor);
return myTensor;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2,3,4],"Symmetric");

	if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be totally symmetric. Recieved", DGErrorPrint(myomegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=evalDG(omega &t epsilon2bar &t epsilon2bar):
term2:=evalDG(epsilon2 &t epsilon2 &t myomegabar):
term3:=RearrangeIndices(term1,[1,3,5,7,2,6,4,8]):
term4:=RearrangeIndices(term2,[1,5,3,7,2,4,6,8]):
myFrankESpinor:=(term3 &plus term4):
myTensor:=SpinorHook(sigma,myFrankESpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*71*)

Rank4GeneratePiTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,term1,term2,term3,term4,myCurlyESpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[1,2,3,4,5,7,6,8]);
term2:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[3,4,5,6,1,7,2,8]);
term3:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[5,6,7,8,1,3,2,4]);
term4:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[1,2,7,8,3,5,4,6]);
myCurlyESpinor:=(term1 &minus term2 &plus term3 &minus term4);
myTensor:=SpinorHook(sigma,myCurlyESpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*72*)

Rank4GenerateChiTensor:=proc(omega,sigma)
local epsilon2,epsilon2bar,term1,term2,myTraceESpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=RearrangeIndices(epsilon2 &t epsilon2 &t epsilon2bar &t epsilon2bar,[1,3,5,7,2,4,6,8]):
term2:=RearrangeIndices(epsilon2 &t epsilon2 &t epsilon2bar &t epsilon2bar,[1,7,3,5,2,8,4,6]):
myTraceESpinor:=(omega &mult (term1 &minus term2)):
myTensor:=SpinorHook(sigma,myTraceESpinor):
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*73*)

Rank4GeneratePsiTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,term1,term2,term3,term4,myFrankFSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric. Recieved", DGErrorPrint(omega)

	fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=evalDG(omega &t epsilon2bar &t epsilon2bar):
term2:=evalDG(epsilon2 &t epsilon2 &t omegabar):
term3:=RearrangeIndices(term1,[1,3,5,7,2,4,6,8]):
term4:=RearrangeIndices(term2,[1,3,5,7,2,4,6,8]):
myFrankFSpinor:=(term3 &plus term4):
myTensor:=SpinorHook(sigma,myFrankFSpinor);
return myTensor;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2,3,4],"Symmetric");

	if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be totally symmetric. Recieved", DGErrorPrint(myomegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2,3,4],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=evalDG(omega &t epsilon2bar &t epsilon2bar):
term2:=evalDG(epsilon2 &t epsilon2 &t myomegabar):
term3:=RearrangeIndices(term1,[1,3,5,7,2,4,6,8]):
term4:=RearrangeIndices(term2,[1,3,5,7,2,4,6,8]):
myFrankFSpinor:=(term3 &plus term4):
myTensor:=SpinorHook(sigma,myFrankFSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*74*)

Rank4GeneratePhiTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,myCurlyFSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[1,2,5,6,3,7,4,8]):
term2:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[3,4,5,6,1,7,2,8]):
term3:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[3,4,7,8,1,5,2,6]):
term4:=RearrangeIndices(omega &t epsilon2 &t epsilon2bar,[1,2,7,8,3,5,4,6]):
myCurlyFSpinor:=(term1 &minus term2 &plus term3 &minus term4):
myTensor:=SpinorHook(sigma,myCurlyFSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*75*)

Rank4GenerateLambdaTensor:=proc(omega,sigma)
local epsilon2,epsilon2bar,term1,term2,myTraceFSpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
term1:=RearrangeIndices(epsilon2 &t epsilon2 &t epsilon2bar &t epsilon2bar,[1,5,3,7,2,6,4,8]):
term2:=RearrangeIndices(epsilon2 &t epsilon2 &t epsilon2bar &t epsilon2bar,[1,7,3,5,2,8,4,6]):
myTraceFSpinor:=(omega &mult (term1 &minus term2)):
myTensor:=SpinorHook(sigma,myTraceFSpinor):
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*76*)

Rank4GenerateTauTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1a,term1b,term2a,term2b,term3a,term3b,myFrankGSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega);
term1a:=RearrangeIndices(baseterm,[3,7,2,6,1,4,5,8]);
term1b:=RearrangeIndices(baseterm,[1,5,4,8,3,2,7,6]);
term2a:=RearrangeIndices(baseterm,[5,7,2,4,1,6,3,8]);
term2b:=RearrangeIndices(baseterm,[1,3,6,8,5,2,7,4]);
term3a:=RearrangeIndices(baseterm,[3,5,2,8,1,4,7,6]);
term3b:=RearrangeIndices(baseterm,[1,7,4,6,3,2,5,8]);
myFrankGSpinor:=(((-3) &mult term1a &minus term1b &plus term2a  &plus ((3) &mult term2b) &plus ((3) &mult term3a) &plus term3b));
myTensor:=SpinorHook(sigma,myFrankGSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*77*)

Rank4GenerateNuTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,myPtensor,g,term1,term2,term3,myCurlyG;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myPtensor:=(2) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar)  &plus  (epsilon2 &tensor omegabar)),[1,3,2,4])):
g:=SpinorInnerProduct(sigma,sigma);
term1:=evalDG(g &t myPtensor):
term2:=RearrangeIndices(term1,[2,3,1,4]):
term3:=RearrangeIndices(term1,[2,4,1,3]):
myCurlyG:=(1/2) &mult ((term1 &minus term2 &plus term3)):
return myCurlyG;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myPtensor:=(2) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar)  &plus  (epsilon2 &tensor myomegabar)),[1,3,2,4])):
g:=SpinorInnerProduct(sigma,sigma);
term1:=evalDG(g &t myPtensor):
term2:=RearrangeIndices(term1,[2,3,1,4]):
term3:=RearrangeIndices(term1,[2,4,1,3]):
myCurlyG:=(1/2) &mult ((term1 &minus term2 &plus term3)):
return myCurlyG;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*78*)

Rank4GenerateZetaTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1a,term1b,term2a,term2b,term3a,term3b,myFrankHSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega):
term1a:=RearrangeIndices(baseterm,[3,7,2,6,1,4,5,8]):
term1b:=RearrangeIndices(baseterm,[1,5,4,8,3,2,7,6]):
term2a:=RearrangeIndices(baseterm,[5,7,2,4,1,6,3,8]):
term2b:=RearrangeIndices(baseterm,[1,3,6,8,5,2,7,4]):
term3a:=RearrangeIndices(baseterm,[3,5,2,8,1,4,7,6]):
term3b:=RearrangeIndices(baseterm,[1,7,4,6,3,2,5,8]):
myFrankHSpinor:=((-1) &mult term1a &minus ((3) &mult term1b) &plus ((3) &mult term2a) &plus term2b &plus ((3) &mult term3a) &plus term3b):
myTensor:=SpinorHook(sigma,myFrankHSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*79*)

Rank4GenerateEtaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,myRtensor,g,term1,term2,term3,myCurlyH;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myRtensor:=(2) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar) &plus (epsilon2 &tensor omegabar)),[1,3,2,4]));
g:=SpinorInnerProduct(sigma,sigma);
term3:=evalDG(myRtensor &t g):
term1:=RearrangeIndices(term3,[2,4,1,3]):
term2:=RearrangeIndices(term3,[1,4,2,3]):
myCurlyH:=(1/2) &mult ((term1 &minus term2 &plus term3)):
return myCurlyH;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myRtensor:=(2) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar) &plus (epsilon2 &tensor myomegabar)),[1,3,2,4]));
g:=SpinorInnerProduct(sigma,sigma);
term3:=evalDG(myRtensor &t g):
term1:=RearrangeIndices(term3,[2,4,1,3]):
term2:=RearrangeIndices(term3,[1,4,2,3]):
myCurlyH:=(1/2) &mult ((term1 &minus term2 &plus term3)):
return myCurlyH;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*80*)

Rank4GenerateXiTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term1a,term1b,term2a,term2b,term3a,term3b,myFrankJSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega);
term1a:=RearrangeIndices(baseterm,[3,7,2,6,1,4,5,8]):
term1b:=RearrangeIndices(baseterm,[1,5,4,8,3,2,7,6]):
term2a:=RearrangeIndices(baseterm,[5,7,2,4,1,6,3,8]):
term2b:=RearrangeIndices(baseterm,[1,3,6,8,5,2,7,4]):
term3a:=RearrangeIndices(baseterm,[3,5,2,8,1,4,7,6]):
term3b:=RearrangeIndices(baseterm,[1,7,4,6,3,2,5,8]):
myFrankJSpinor:=(((-1) &mult term1a) &plus term1b &plus term2a &minus term2b &minus term3a &plus term3b):
myTensor:=SpinorHook(sigma,myFrankJSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*81*)

Rank4GenerateSigmaTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,myUtensor,g,term1,term2,term3,myCurlyJ;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myUtensor:=(2) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar) &plus (epsilon2 &tensor omegabar)),[1,3,2,4])):
g:=SpinorInnerProduct(sigma,sigma);
term3:=evalDG(myUtensor &t g):
term1:=RearrangeIndices(term3,[2,3,1,4]):
term2:=RearrangeIndices(term3,[1,3,2,4]):
myCurlyJ:=(1/2) &mult ((term1 &minus term2 &plus term3)):
return myCurlyJ;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myUtensor:=(2) &mult SpinorHook(sigma,RearrangeIndices(((omega &tensor epsilon2bar) &plus (epsilon2 &tensor myomegabar)),[1,3,2,4])):
g:=SpinorInnerProduct(sigma,sigma);
term3:=evalDG(myUtensor &t g):
term1:=RearrangeIndices(term3,[2,3,1,4]):
term2:=RearrangeIndices(term3,[1,3,2,4]):
myCurlyJ:=(1/2) &mult ((term1 &minus term2 &plus term3)):
return myCurlyJ;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*82*)

Rank4GenerateAlephTensor:=proc(omega,sigma)
local epsilon2,epsilon2bar,baseterm,term1,term2,term3,term4,term5,term6,myFrankKSpinor,myTensor;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2 &t epsilon2bar &t epsilon2bar):
term1:=RearrangeIndices(baseterm,[1,2,3,4,5,7,6,8]):
term2:=RearrangeIndices(baseterm,[1,2,3,4,5,8,6,7]):
term3:=RearrangeIndices(baseterm,[1,3,2,4,5,8,6,7]):
term4:=RearrangeIndices(baseterm,[1,3,2,4,5,6,7,8]):
term5:=RearrangeIndices(baseterm,[1,4,2,3,5,6,7,8]):
term6:=RearrangeIndices(baseterm,[1,4,2,3,5,7,6,8]):
myFrankKSpinor:=RearrangeIndices((omega &mult (term1 &plus term2 &plus term3 &minus term4 &minus term5 &minus term6)),[1,3,5,7,2,4,6,8]):
myTensor:=SpinorHook(sigma,myFrankKSpinor):
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*83*)

CurvatureFrankL:=proc(A,g)
local FrankH,FrankJ,FrankL;
FrankH:=Rank4FrankH(A,g):
FrankJ:=Rank4FrankJ(A,g):
FrankL:=(FrankH &plus FrankJ):
return FrankL:
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*84*)

CurvatureCurlyL:=proc(A,g)
local CurlyH,CurlyJ,CurlyL;
CurlyH:=Rank4CurlyH(A,g):
CurlyJ:=Rank4CurlyJ(A,g):
CurlyL:=(CurlyH &plus CurlyJ):
return CurlyL:
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*85*)

CurvatureZheSpinor:=proc(T,sigma)
local g,h,N,FrankH,FrankJ,FrankL,FrankLSpinor,epsilon1,epsilon1bar,ZheSpinor;
g:=SpinorInnerProduct(sigma,sigma);
FrankH:=Rank4FrankH(T,g):
FrankJ:=Rank4FrankJ(T,g):
FrankL:=(FrankH &plus FrankJ):
FrankLSpinor:=SpinorHook(sigma,FrankL):
epsilon1:=EpsilonSpinor("con","spinor");
epsilon1bar:=EpsilonSpinor("con","barspinor");
ZheSpinor:=(1/2) &mult ContractIndices(epsilon1 &t epsilon1bar,FrankLSpinor,[[1,1],[2,5],[3,2],[4,4]]):
return ZheSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*86*)

CurvatureYuSpinor:=proc(B,sigma,o:= "spinor")
local g,h,N,epsilon1bar,epsilon1,CurlyH,CurlyJ,CurlyL,CurlyLSpinor,TheTensor,TheSpinor,YuSpinor,YuBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1bar:=EpsilonSpinor("con","barspinor");
CurlyH:=Rank4CurlyH(B,g):
CurlyJ:=Rank4CurlyJ(B,g):
CurlyL:=(CurlyH &plus CurlyJ):
TheTensor:=ContractIndices(h,CurlyL,[[1,1],[2,3]]):
TheSpinor:=SpinorHook(sigma,TheTensor):
YuSpinor:=(1/4) &mult ContractIndices(epsilon1bar,TheSpinor,[[1,2],[2,4]]):
return YuSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
N:=DGinfo("FrameBaseDimension");
epsilon1:=EpsilonSpinor("con","spinor");
CurlyH:=Rank4CurlyH(B,g):
CurlyJ:=Rank4CurlyJ(B,g):
CurlyL:=(CurlyH &plus CurlyJ):
TheTensor:=ContractIndices(h,CurlyL,[[1,1],[2,3]]):
TheSpinor:=SpinorHook(sigma,TheTensor):
YuBarSpinor:=(1/4) &mult ContractIndices(epsilon1,TheSpinor,[[1,1],[2,3]]):
return YuBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*87*)

CurvatureGenerateZheTensor:=proc(omega,sigma)
local SymmetryCheck1,SymmetryCheck2,epsilon2,epsilon2bar,baseterm,term2a,term2b,myFrankLSpinor,myTensor;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,3],"Symmetric");
SymmetryCheck2:=SymmetrizeIndices(omega,[2,4],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true or DGequal(SymmetryCheck2,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices, and the last two indices seperately. Recieved", DGErrorPrint(omega)

else

#It is also important to check that this spinor is antihermitian, or else the tensor produced will not be real.

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=evalDG(epsilon2 &t epsilon2bar &t omega):
term2a:=RearrangeIndices(baseterm,[5,7,2,4,1,6,3,8]):
term2b:=RearrangeIndices(baseterm,[1,3,6,8,5,2,7,4]):
myFrankLSpinor:=evalDG(term2b &minus term2a):
myTensor:=SpinorHook(sigma,myFrankLSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*88*)

CurvatureGenerateYuTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,omegabar1,omegabar,epsilon2,epsilon2bar,baseterm,term2,term3,term4,term5,myCurlyLSpinor,myTensor;

###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

omegabar1:=ConjugateSpinor(omega);
omegabar:=simplify(omegabar1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=(epsilon2bar &tensor epsilon2 &tensor ((epsilon2bar &tensor omega) &plus (omegabar &tensor epsilon2))):
term2:=RearrangeIndices(baseterm,[2,6,1,5,4,8,3,7]):
term3:=RearrangeIndices(baseterm,[4,6,3,5,2,8,1,7]):
term4:=RearrangeIndices(baseterm,[2,8,1,7,4,6,3,5]):
term5:=RearrangeIndices(baseterm,[4,8,3,7,2,6,1,5]):
myCurlyLSpinor:=(term2 &minus term3 &minus term4 &plus term5):
myTensor:=SpinorHook(sigma,myCurlyLSpinor);
return myTensor;


###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first 2 indices. Recieved", DGErrorPrint(omega)

fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
baseterm:=(epsilon2bar &tensor epsilon2 &tensor ((epsilon2bar &tensor omega) &plus (myomegabar &tensor epsilon2))):
term2:=RearrangeIndices(baseterm,[2,6,1,5,4,8,3,7]):
term3:=RearrangeIndices(baseterm,[4,6,3,5,2,8,1,7]):
term4:=RearrangeIndices(baseterm,[2,8,1,7,4,6,3,5]):
term5:=RearrangeIndices(baseterm,[4,8,3,7,2,6,1,5]):
myCurlyLSpinor:=(term2 &minus term3 &minus term4 &plus term5):
myTensor:=SpinorHook(sigma,myCurlyLSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*89*)

JoshSolderForm := proc(OrthonormalFrame, {indextype := ["cov", "con", "con"]})
local Omega, SpinVectors, sigma, m, Fr, i, g, h, Sigma;
if not OrthonormalFrame::list(DGvector) then

error "expected a list of 4 vectors. Received %1", DifferentialGeometry:-DGErrorPrint(OrthonormalFrame)

elif nops(OrthonormalFrame) <> 4 then

error "expected a list of 4 vectors. Received %1 vectors", nops(OrthonormalFrame)
      
end if;

Fr := DifferentialGeometry:-Tools:-DGinfo(OrthonormalFrame[1],"ObjectFrame");
m := DifferentialGeometry:-Tools:-DGinfo(Fr,"FrameFiberDimension");

      ####### Dimension Issue here
      #  if m <> 4 then
      #    print("Fiber dimension of frame is usually 4. Received ", m)
      #  end if;
      ####### Dimension Issue here end

Omega := DifferentialGeometry:-DualBasis(OrthonormalFrame,DifferentialGeometry:-Tools:-DGinfo("FrameBaseForms"));
SpinVectors := DifferentialGeometry:-Tools:-DGinfo("FrameFiberVectors");
sigma := table();
sigma[2] := DifferentialGeometry:-evalDG((`&t`(SpinVectors[2],SpinVectors[3])+`&t`(SpinVectors[1],SpinVectors[4]))/sqrt(2));
sigma[3] := DifferentialGeometry:-evalDG(I*(`&t`(SpinVectors[2],SpinVectors[3])-`&t`(SpinVectors[1],SpinVectors[4]))/sqrt(2));
sigma[4] := DifferentialGeometry:-evalDG((`&t`(SpinVectors[1],SpinVectors[3])-`&t`(SpinVectors[2],SpinVectors[4]))/sqrt(2));
sigma[1] := DifferentialGeometry:-evalDG((`&t`(SpinVectors[1],SpinVectors[3])+`&t`(SpinVectors[2],SpinVectors[4]))/sqrt(2));
Sigma := DifferentialGeometry:-evalDG(add(`&t`(Omega[i],sigma[i]),i = 1 .. 4));
      
if not indextype::list(string) then

error "expected 2nd (optional) argument to be a 3 element list of  spinor-tensor index types {\"con\", \"cov\"}. Received %1", indextype

elif nops(indextype) <> 3 then

error "expected 2nd (optional) argument to be a 3 element list of  spinor-tensor index types {\"con\", \"cov\"}. Received %1", indextype

end if;

if indextype[1] = "con" then

g := DifferentialGeometry:-Tensor:-SpinorInnerProduct(Sigma,Sigma);

if not g::DGmetric then

error "the  1st argument (solder form) does not determine a non-singular metric"
        
end if;
        
h := DifferentialGeometry:-Tensor:-InverseMetric(g);
Sigma := DifferentialGeometry:-Tensor:-RaiseLowerIndices(h,Sigma,[1])

end if;

if indextype[2] = "cov" then

Sigma := JoshRaiseLowerSpinorIndices(Sigma,[2])

end if;

if indextype[3] = "cov" then

Sigma := JoshRaiseLowerSpinorIndices(Sigma,[3])

end if;

Sigma

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*90*)

JoshRaiseLowerSpinorIndices := proc(S0, indexlist)
local S, Fr, m, SpinVectors, SpinForms, R, i, epsilon1, epsilon2, Indices, k;
if nargs <> 2 then

error "expected 2 arguments [tensor-spinor,index list]. Received %1", nargs

end if;

S := DifferentialGeometry:-evalDG(S0);

if not S::('{DGform, DGtensor, DGvector}') then

error "expected 1st argument to be a tensor-spinor, vector, or form. Received %1", DGErrorPrint(S)

end if;
     
if S::{DGform, DGvector} then

S := convert(S,DGtensor)

end if;
     
Fr := DifferentialGeometry:-Tools:-DGinfo(S,"ObjectFrame");
m := DifferentialGeometry:-Tools:-DGinfo(Fr,"FrameFiberDimension");

     ####### Dimension Issue here
     #  if m <> 4 then
     #    print("Fiber dimension of frame is usually 4. Received ", m)
     #  end if;
     ####### Dimension Issue here end

SpinVectors := DifferentialGeometry:-Tools:-DGinfo(Fr,"FrameFiberVectors");
SpinForms := DifferentialGeometry:-Tools:-DGinfo(Fr,"FrameFiberForms");
epsilon1 := DifferentialGeometry:-evalDG(`&t`(SpinForms[1],SpinForms[2])-`&t`(SpinForms[2],SpinForms[1])+`&t`(SpinForms[3],SpinForms[4])-`&t`(SpinForms[4],SpinForms[3]));
epsilon2 := DifferentialGeometry:-evalDG(`&t`(SpinVectors[1],SpinVectors[2])-`&t`(SpinVectors[2],SpinVectors[1])+`&t`(SpinVectors[3],SpinVectors[4])-`&t`(SpinVectors[4],SpinVectors[3]));
Indices := DifferentialGeometry:-Tools:-DGinfo(S,"TensorIndexType");
R := S;

for i in indexlist do
   if nops(Indices) < i then
      
   error "the index %1 exceeds the total rank %2 of tensor-spinor(1st argument)", i, nops(Indices)
   
   elif Indices[i] = "con_vrt" then

   R := DifferentialGeometry:-Tensor:-ContractIndices(epsilon1,R,[[1, i]]);
   
   if i <> 1 then
     
   R := DifferentialGeometry:-Tensor:-RearrangeIndices(R,[[seq(i-k+1,k = 1 .. i)]])
   
   end if
   
   elif Indices[i] = "cov_vrt" then
         
   R := DifferentialGeometry:-Tensor:-ContractIndices(epsilon2,R,[[2, i]]);
   
   if i <> 1 then
          
   R := DifferentialGeometry:-Tensor:-RearrangeIndices(R,[[seq(i-k+1,k = 1 .. i)]])
   
   end if

   else
         
   error "expected index type of index, %1, to be \"con_vrt\" or \"cov_vrt\". Received %2", i, Indices[i]
       
   end if
end do;

DifferentialGeometry:-DGsimplify(R)

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*91*)

JoshSpinorInnerProduct := proc(A0, B0)
local A, B, IndexTypeA, IndexTypeB, Index2A, IndA, NumberOfTensorIndicesA, SpinorIndexTypeA, Index2B, IndB, NumberOfTensorIndicesB, SpinorIndexTypeB, n, i, R, C, TF, t, mA, mB, ans;
if nargs <> 2 then

error "expected 2 agruments [spin-tensor, spin-tensor]. Received %1 arguments", nargs
     
end if;

A := DifferentialGeometry:-evalDG(A0);
B := DifferentialGeometry:-evalDG(B0);
     
if not A::{DGform, DGtensor, DGvector} then

error "expected 1st argument to be vector, form or tensor. Received %1", DGErrorPrint(A)
     
elif not B::{DGform, DGtensor, DGvector} then
       
error "expected 2nd  argument to be vector, form or tensor. Received %1", DGErrorPrint(B)
       
end if;
     
A := convert(A,DGtensor);
B := convert(B,DGtensor);
IndexTypeA := DifferentialGeometry:-Tools:-DGinfo(A,"TensorIndexType");
Index2A := map(DifferentialGeometry:-Tools:-DGinfo,IndexTypeA,"TensorIndexPart2");
IndA := sort(Index2A);
NumberOfTensorIndicesA := nops(remove(f -> is(f = "vrt"),IndA));
IndexTypeB := DifferentialGeometry:-Tools:-DGinfo(B,"TensorIndexType");
Index2B := map(DifferentialGeometry:-Tools:-DGinfo,IndexTypeB,"TensorIndexPart2");
IndB := sort(Index2B);
NumberOfTensorIndicesB := nops(remove(f -> is(f = "vrt"),IndB));

if IndA <> Index2A then
       
error "expected all space-time indices to occur before spinor indices. Index type of 1st argument is %1", IndexTypeA
     
elif IndB <> Index2B then
       
error "expected all space-time indices to occur before spinor indices. Index type of 2nd argument is %1", IndexTypeB
     
end if;
     
SpinorIndexTypeA := IndexTypeA[NumberOfTensorIndicesA+1 .. -1];
SpinorIndexTypeB := IndexTypeB[NumberOfTensorIndicesB+1 .. -1];
     
if SpinorIndexTypeA <> SpinorIndexTypeB then
       
error "expected spinor index type of first argument %1, to = spinor index type of second argument %2", IndexTypeA, IndexTypeB
     
end if;
     
TF := member("vrt",Index2A);
     
if TF = ('false') then
       
return DifferentialGeometry:-`&tensor`(A,B)
     
end if;
     
n := nops(IndexTypeA);
mA := NumberOfTensorIndicesA;
mB := NumberOfTensorIndicesB;
R := [seq(i,i = mA+1 .. n)];
C := [seq([i+mA, i+mB],i = 1 .. n-mA)];
t := nops(remove(f -> is(Tools:-DGinfo(f,"TensorIndexPart1") = "con"),SpinorIndexTypeA));
ans := DifferentialGeometry:-Tensor:-ContractIndices(JoshRaiseLowerSpinorIndices(A,R),B,C);
DifferentialGeometry:-`&mult`:-Main((-1)^t,ans)

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*92*)

Rank2SSpinor:=proc(B,sigma)
local g,term4,FrankASpinor;
g:=SpinorInnerProduct(sigma,sigma);
term4:=Rank2FrankA(B,g);
FrankASpinor:=SpinorHook(sigma,term4);
return FrankASpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*93*)

Rank2TauSpinor:=proc(B,sigma)
local g,h,term1,tauSpinor;
g:=SpinorInnerProduct(sigma,sigma);
h:=InverseMetric(g);
term1:=Rank2TraceA(B,g);
tauSpinor:=(1/4)*ContractIndices(h,term1,[[1,1],[2,2]]);
return tauSpinor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*94*)

Rank2PsiSpinor:=proc(B,sigma,o:= "spinor")
local g,epsilon1,epsilon1bar,term3,FrankBSpinor,psiSpinor,psiBarSpinor;

if o="spinor" then

g:=SpinorInnerProduct(sigma,sigma);
term3:=Rank2FrankB(B,g):
FrankBSpinor:=SpinorHook(sigma,term3):
epsilon1bar:=EpsilonSpinor("con","barspinor");
psiSpinor:=ContractIndices(1/2*epsilon1bar, FrankBSpinor,[[1,2],[2,4]]):
return psiSpinor;

elif o="barspinor" then

g:=SpinorInnerProduct(sigma,sigma);
term3:=Rank2FrankB(B,g):
FrankBSpinor:=SpinorHook(sigma,term3):
epsilon1:=EpsilonSpinor("con","spinor");
psiBarSpinor:=ContractIndices(1/2*epsilon1, FrankBSpinor,[[1,1],[2,3]]):
return psiBarSpinor;

else

error "expected 3rd argument to be either 'spinor' or 'barspinor' Recieved", DGErrorPrint(o)

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*95*)

Rank2GenerateSTensor:=proc(omega,sigma)
local myTensor;
myTensor:=SpinorHook(sigma,omega);
return myTensor;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*96*)

Rank2GenerateTauTensor:=proc(B,sigma)
local epsilon2,epsilon2bar,myTraceASpinor1,myTraceASpinor,myTraceA;
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
myTraceASpinor1:=B &mult evalDG(epsilon2 &t epsilon2bar):
myTraceASpinor:=RearrangeIndices(myTraceASpinor1,[1,3,2,4]):
myTraceA:=SpinorHook(sigma,TraceASpinor):
return myTraceA;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*97*)

Rank2GeneratePsiTensor:=proc(omega,sigma,myomegabar:=0)
local SymmetryCheck1,SymmetryCheck2,psibarSpinor1,psibarSpinor,epsilon2,epsilon2bar,FBSpinorterm1,FBSpinorterm2,myFrankBSpinor,myTensor;
###Case when omegabar is not given###
if myomegabar=0 then

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be totally symmetric in the first two indices. Recieved", DGErrorPrint(omega)

else

psibarSpinor1:=ConjugateSpinor(omega);
psibarSpinor:=simplify(psibarSpinor1);
epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FBSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2bar),[1,3,2,4]):
FBSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t psibarSpinor),[1,3,2,4]):
myFrankBSpinor:=(FBSpinorterm1 &plus FBSpinorterm2):
myTensor:=SpinorHook(sigma,myFrankBSpinor);
return myTensor;

fi;

###Case when omegabar is given###

else

SymmetryCheck2:=SymmetrizeIndices(myomegabar,[1,2],"Symmetric");

	if DGequal(SymmetryCheck2,myomegabar)<>true then 

error "expected 3rd argument be symmetric in the first two indices. Recieved", DGErrorPrint(myomegabar)

	fi;

SymmetryCheck1:=SymmetrizeIndices(omega,[1,2],"Symmetric");

	if DGequal(SymmetryCheck1,omega)<>true then 

error "expected 1st argument be symmetric in the first two indices. Recieved", DGErrorPrint(omega)

	fi;

epsilon2:=EpsilonSpinor("cov","spinor");
epsilon2bar:=EpsilonSpinor("cov","barspinor");
FBSpinorterm1:=RearrangeIndices(evalDG(omega &t epsilon2bar),[1,3,2,4]):
FBSpinorterm2:=RearrangeIndices(evalDG(epsilon2 &t myomegabar),[1,3,2,4]):
myFrankBSpinor:=(FBSpinorterm1 &plus FBSpinorterm2):
myTensor:=SpinorHook(sigma,myFrankBSpinor);
return myTensor;

fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*98*)

PlebanskiSpinorClassification:=proc(aSpinor)
local Dz1,Dz2,Dw1,Dw2,Phi00,Phi01,Phi02,Phi10,Phi11,Phi12,Phi20,Phi21,Phi22,
chi0,chi1,chi2,chi3,chi4,
QTilde0,QTilde1,QTilde2,QTilde3,QTilde4,
Rtilde0,Rtilde1,Rtilde2,Rtilde3,Rtilde4,Rtilde5,Rtilde6,
myIP,myJP,
myDelta;

Dz1:=DGinfo("FrameFiberVectors")[1];
Dz2:=DGinfo("FrameFiberVectors")[2];
Dw1:=DGinfo("FrameFiberVectors")[3];
Dw2:=DGinfo("FrameFiberVectors")[4];

#Build the Phi Scalars:
Phi00:=simplify(Hook([Dz1,Dz1,Dw1,Dw1],aSpinor));
Phi01:=simplify(Hook([Dz1,Dz1,Dw1,Dw2],aSpinor));
Phi02:=simplify(Hook([Dz1,Dz1,Dw2,Dw2],aSpinor));
Phi10:=simplify(Hook([Dz1,Dz2,Dw1,Dw1],aSpinor));
Phi11:=simplify(Hook([Dz1,Dz2,Dw1,Dw2],aSpinor));
Phi12:=simplify(Hook([Dz1,Dz2,Dw2,Dw2],aSpinor));
Phi20:=simplify(Hook([Dz2,Dz2,Dw1,Dw1],aSpinor));
Phi21:=simplify(Hook([Dz2,Dz2,Dw1,Dw2],aSpinor));
Phi22:=simplify(Hook([Dz2,Dz2,Dw2,Dw2],aSpinor));

#Build the Chi Scalars from the Phi Scalars:
chi0:=simplify(2*Phi00*Phi02-2*Phi01^2);
chi1:=simplify(Phi00*Phi12-2*Phi01*Phi11+Phi02*Phi10);
chi2:=simplify((Phi00*Phi22-2*Phi01*Phi21+Phi02*Phi20+4*Phi12*Phi10-4*Phi11^2)/3);
chi3:=simplify(Phi10*Phi22-2*Phi11*Phi21+Phi12*Phi20);
chi4:=simplify(2*Phi20*Phi22-2*Phi21^2);

#Check if Type O, chi=0
if chi0=0 and chi1=0 and chi2=0 and chi3=0 and chi4=0 then
#print("Type O");
return "Type O";
fi;

#Build the Q Scalars from the chi Scalars:
QTilde0:=simplify(2*chi0*chi2-2*chi1^2);
QTilde1:=simplify(chi0*chi3-chi1*chi2);
QTilde2:=simplify((1/3)*chi0*chi4+(2/3)*chi1*chi3-chi2^2);
QTilde3:=simplify(chi1*chi4-chi2*chi3);
QTilde4:=simplify(2*chi2*chi4-2*chi3^2);

#Check if Type N {IV}, Q=0
if QTilde0=0 and QTilde1=0 and QTilde2=0 and QTilde3=0 and QTilde4=0 then
#print("Type N");
return "Type N";
fi;

#Build the R Scalars from the QTilde & chi Scalars:
Rtilde0:=simplify(QTilde0*chi1-QTilde1*chi0);
Rtilde1:=simplify((QTilde0*chi2-QTilde2*chi0)/2);
Rtilde2:=simplify(QTilde1*chi2-QTilde2*chi1);
Rtilde3:=simplify((QTilde1*chi3-QTilde3*chi1)/2);
Rtilde4:=simplify(QTilde2*chi3-QTilde3*chi2);
Rtilde5:=simplify((QTilde2*chi4-QTilde4*chi2)/2);
Rtilde6:=simplify(QTilde3*chi4-QTilde4*chi3);

#Check if Type D, R=0
if Rtilde0=0 and Rtilde1=0 and Rtilde2=0 and Rtilde3=0 and Rtilde4=0 and Rtilde5=0 and Rtilde6=0 then
#print("Type D");
return "Type D";
fi;

#Build the I & J Scalars from the QTilde & chi Scalars:
myIP:=simplify((1/3)*chi0*chi4-(4/3)*chi1*chi3+chi2^2);
myJP:=simplify(chi0*chi2*chi4-chi0*chi3^2-chi1^2*chi4+2*chi1*chi2*chi3-chi2^3);

#Check if Type III, I=0 and J=0
if myIP=0 and myJP=0 then
#print("Type III");
return "Type III";
fi;

#Build the Delta Scalar (Discriminant) from the chi Scalars:
myDelta:=simplify(myJP^2-myIP^3);

#Check if Type II, D=0
if myDelta=0 then
#print("Type II");
return "Type II";
else
#else Type I
#print("Type I");
return "Type I"
fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*99*)

RicciSpinorIrreducibilityAlgorithm:=proc(aRicciSpinor)
local myPhi,myPhi2,myPhi3,myI6,myI62,myI63,myE,myE2,myE3,myI7,myI72,myI73,myChiTilde,myChiTilde2,myChiTilde3,myRTilde,myRTilde2,myRTilde3;

#1.) Calculate Phi List
myPhi:=SegrePhiCovariant(aRicciSpinor);

#Get rhs:
myPhi2:=map(rhs,myPhi);

#Convert to set
myPhi3:=convert(myPhi2,set);

#Check if Case 8, Phi=0
if myPhi3={0} then
print("Case 8, (-), ZERO");
return "(-)";
fi;

#2.) Calculate I6
myI6:=SegreI6Invariant(aRicciSpinor);

#Get rhs:
myI62:=map(rhs,myI6);

#Convert to set
myI63:=convert(myI62,set);

#Check if Case 7, I6=0
if myI63={0} then
print("Case 7, |(1,0)|^2, rho & rho & rhoBar & rhoBar");
return "|(1,0)^2|^2";
fi;

#3.) Calculate E List

myE:=SegreECovariant(aRicciSpinor);

#Get rhs:
myE2:=map(rhs,myE);

#Convert to set
myE3:=convert(myE2,set);

#Check if Case 6, E=0
if myE3={0} then
print("Case 6, |(1,0)(1,0)|^2, rho & sigma & rhoBar & sigmaBar");
return "|(1,0)(1,0)|^2";
fi;

#4.) Calculate I7

myI7:=SegreI7Invariant(aRicciSpinor);

#Get rhs:
myI72:=map(rhs,myI7);

#Convert to set
myI73:=convert(myI72,set);

#Check if Case 5, I7=0
if myI73={0} then
print("Case 5, (1,1)|(1,0)|^2, rho & Lambda & rhoBar");
return "(1,1)|(1,0)|^2";
fi;

#5.) Calculate Chi Tilde List

myChiTilde:=SegreChiTildeCovariant(aRicciSpinor);

#Get rhs:
myChiTilde2:=map(rhs,myChiTilde);

#Convert to set
myChiTilde3:=convert(myChiTilde2,set);

#Check if Case 4, myChiTilde=0
if myChiTilde3={0} then
print("Case 4, (1,1)^2, Lambda & Lambda");
return "(1,1)^2";
fi;

#6.) Calculate R List

myRTilde:=SegreRTildeCovariant(aRicciSpinor);

#Get rhs:
myRTilde2:=map(rhs,myRTilde);

#Convert to set
myRTilde3:=convert(myRTilde2,set);

#Check if Case 3 or 2 then  Rtilde=0, or if Case 1 then Rtilde <>0
if myRTilde3={0} then
print("Case 2 or 3, (1,1)(1,1) or |(1,1)|^2, Lambda & Upsilon OR Gamma & GammaBar");
return "(1,1)(1,1) or |(1,1)|^2";
else
print("Case 1, (2,2), Phi Irreducible");
return "(2,2)"
fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*100*)

CurvatureYuCovariant:=proc(aYuSpinor)
local FiberBasis,Dz1,Dz2,myYu00,myYu01,myYu11,myYuList;

FiberBasis:=DGinfo("FrameFiberVectors");

Dz1:=FiberBasis[1];
Dz2:=FiberBasis[2];

myYu00:=Hook([Dz1,Dz1],aYuSpinor);
myYu01:=Hook([Dz1,Dz2],aYuSpinor);
myYu11:=Hook([Dz2,Dz2],aYuSpinor);

myYuList:=[Yu00=myYu00,Yu01=myYu01,Yu11=myYu11];

return myYuList;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*101*)

CurvatureOmicronInvariant:=proc(aYuSpinor)
local myYuList,myOmicronInvariant;

myYuList:=CurvatureYuCovariant(aYuSpinor);

myOmicronInvariant:=simplify(eval([Omicron=2*Yu00*Yu11-2*Yu01^2],myYuList));

return myOmicronInvariant;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*102*)

CurvatureYuReducibilityAlgorithm:=proc(aYuSpinor)
local Yu,YuSet,Omicron,OmicronSet;

#Step 1: Calculate Yu:
Yu:=CurvatureYuCovariant(aYuSpinor);
YuSet:=convert(map(rhs,Yu),set);

#if YuSet={0} then Case 3:
if YuSet={0} then
print("Case 3, [-]-(-), the zero spinor");
return "[(11)]";
fi;

#Step 2: Calculate Omicron:
Omicron:=CurvatureOmicronInvariant(aYuSpinor);
OmicronSet:=convert(map(rhs,Omicron),set);

#if OmicronSet={0} then Case 3:
if OmicronSet={0} then
print("Case 2, [(11)]-(1,0)^2, alpha & alpha");
return "[2]";
else
print("Case 1, [11]-(1,0)(1,0), alpha & beta");
return "[11]";
fi;

end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*103*)

CurvatureTensorReducibilityAlgorithm:=proc(aCurvatureTensor,aSolder,o:="Basic")
local g,myCurvatureTensor,myPsi,myPhi,myLambda,myZhe,myYu,myAleph,WS,PsiType,PhiType_Spinor,RS,PhiType_Segre,ZheType_Spinor,ZS,ZheType_Segre,YuType,LambdaType,AlephType,myList,PhiType_Plebanski,ZheType_Plebanski;

###Optional Arguement "o" which will determine the Plebanski Type in addition to the Segre Type (In case the Segre Type Fails).

g:=SpinorInnerProduct(aSolder,aSolder);

###Here we add a piece to classify the Curvature tensor if it comes with a contravariant index

if DGinfo(aCurvatureTensor,"TensorIndexType") = ["con_bas", "cov_bas", "cov_bas", "cov_bas"] then
	
	myCurvatureTensor:=RaiseLowerIndices(g,aCurvatureTensor,[1]);

elif DGinfo(aCurvatureTensor,"TensorIndexType") = ["cov_bas", "cov_bas", "cov_bas", "cov_bas"] then

	myCurvatureTensor:=aCurvatureTensor;

else

	error "invalid tensor type, expecting type ['con_bas', 'cov_bas', 'cov_bas', 'cov_bas'] or ['cov_bas', 'cov_bas', 'cov_bas', 'cov_bas'], Recieved:", DGErrorPrint(aCurvaturerTensor)

fi;

###Now we move onto the classification:

#Get the SL(2,C) irreducible spinors
myPsi:=Rank4PsiSpinor(myCurvatureTensor,sigma):
myPhi:=RearrangeIndices(Rank4PhiSpinor(myCurvatureTensor,sigma),[1,3,2,4]):
myLambda:=Rank4LambdaSpinor(myCurvatureTensor,sigma):
myZhe:=RearrangeIndices(CurvatureZheSpinor(myCurvatureTensor,sigma),[1,3,2,4]):
myYu:=CurvatureYuSpinor(myCurvatureTensor,sigma):
myAleph:=Rank4AlephSpinor(myCurvatureTensor,sigma):

#####Determine the spinor structure reducibility

WS:=table(PetrovPsiCovariant(myPsi));
PsiType:=PetrovType(WS);

PhiType_Spinor:=RicciSpinorIrreducibilityAlgorithm(myPhi);
RS:=table([op(SegrePhiCovariant(myPhi)),"Lambda"=0]);
PhiType_Segre:=SegreType(RS);

ZheType_Spinor:=RicciSpinorIrreducibilityAlgorithm(myZhe);
ZS:=table([op(SegrePhiCovariant(myZhe)),"Lambda"=0]);
ZheType_Segre:=SegreType(ZS);

YuType:=CurvatureYuReducibilityAlgorithm(myYu);

#Classification for Lambda scalar
if is(0 < myLambda) then
	LambdaType:="+";
elif is(myLambda < 0) then
	LambdaType:="-";
elif is(myLambda = 0) then
	LambdaType:="0";
else
	LambdaType:="Indeterminant";
fi;

#Classification for Aleph scalar
###Need the -I times because aleph is anti-hermitian.
###This then calculates if aleph is positivie imaginary, negative imaginary, or zero.
if is(0 < (-I*myAleph)) then
	AlephType:="+I";
elif is((-I*myAleph) < 0) then
	AlephType:="-I";
elif is(myAleph = 0) then
	AlephType:="0";
else
	AlephType:="Indeterminant";
fi;



##### Optional Plebanski Arguement
if o="Basic" then
	#Output a list of all the reducibility types:
	myList:=[Psi=PsiType,Phi=[PhiType_Spinor,PhiType_Segre],Lambda=LambdaType,Zhe=[ZheType_Spinor,ZheType_Segre],Yu=YuType,Aleph=AlephType];

elif o="Plebanski" then
	#Calculate the Plebanski Classification
	PhiType_Plebanski:=PlebanskiSpinorClassification(myPhi);
	ZheType_Plebanski:=PlebanskiSpinorClassification(myZhe);

	#Output a list of all the reducibility types:
	myList:=[Psi=PsiType,Phi=[PhiType_Spinor,PhiType_Segre,PhiType_Plebanski],Lambda=LambdaType,Zhe=[ZheType_Spinor,ZheType_Segre,ZheType_Plebanski],Yu=YuType,Aleph=AlephType];

else

	error "Expecting either 'Plebanski' or 'Basic' , Recieved:", DGErrorPrint(o)

fi;

return myList;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*104*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*105*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*106*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*107*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*108*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*109*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111

end module: