Rank4Tensors := module()
option package;
export 

##########################################################################################
# License: Apache License, Version 2.0
# Copyright [2023] [Joshua James Leiter]
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
##########################################################################################

#Update 11/15/2021
#Made a module for 4th Rank Tensors
#End Update: 11/15/2021

#Update 12/25/2021 *It is Christmas!!
#Edited the Hebrew B,C,D code to return a tensor zero instead of an actual zero.
#Just changed some evalDG's to &plus &minus etc.
#End Update 12/25/2021

#Update 2/1/2023
#Updated code to have h:=InverseMetric(g); piece.
#End Update 2/1/2023

#Below on 1-25 break a rank 4 tensor into its SO(N) irreducible representations.

#(*1*)
	Rank4TraceA,
#(*2*)
	Rank4CurlyA,
#(*3*)
	Rank4FrankA,
#(*4*)
	Rank4CyrillicB,
#(*5*)
	Rank4HebrewB,
#(*6*)
	Rank4FrankB,
#(*7*)
	Rank4CyrillicC,
#(*8*)
	Rank4HebrewC,
#(*9*)
	Rank4FrankC,
#(*10*)
	Rank4CyrillicD,
#(*11*)
	Rank4HebrewD,
#(*12*)
	Rank4FrankD,
#(*13*)
	Rank4TraceE,
#(*14*)
	Rank4CurlyE,
#(*15*)
	Rank4FrankE,
#(*16*)
	Rank4TraceF,
#(*17*)
	Rank4CurlyF,
#(*18*)
	Rank4FrankF,
#(*19*)
	Rank4CurlyG,
#(*20*)
	Rank4FrankG,
#(*21*)
	Rank4CurlyH,
#(*22*)
	Rank4FrankH,
#(*23*)
	Rank4CurlyJ,
#(*24*)
	Rank4FrankJ,
#(*25*)
	Rank4FrankK;

#(*26*)
#(*27*)
#(*28*)
#(*29*)
#(*30*)
#(*31*)
#(*32*)
#(*33*)
#(*34*)
#(*35*)
#(*36*)
#(*37*)
#(*38*)
#(*39*)
#(*40*)
#(*41*)
#(*42*)
#(*43*)
#(*44*)
#(*45*)
#(*46*)
#(*47*)
#(*48*)
#(*49*)
#(*50*)
#(*51*)
#(*52*)
#(*53*)
#(*54*)
#(*55*)
#(*56*)
#(*57*)
#(*58*)
#(*59*)
#(*60*)
#(*61*)
#(*62*)
#(*63*)
#(*64*)
#(*65*)
#(*66*)
#(*67*)
#(*68*)
#(*69*)
#(*70*)
#(*71*)
#(*72*)
#(*73*)
#(*74*)
#(*75*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*1*)

Rank4TraceA:=proc(T,g)
local N,h,Y1,S1,Ptensor, Pscalar,TraceA;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y1:=op(YoungTableauBasis([4], [1,2,3,4], output = "Matrix"));
S1:=YoungSymmetrizer(T,Y1);
Ptensor:=ContractIndices(h,S1,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
TraceA:=SymmetrizeIndices((3/(N*(N+2))*Pscalar) &mult g &t g,[1,2,3,4],"Symmetric");
return TraceA;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*2*)

Rank4CurlyA:=proc(T,g)
local N,h,Y1,S1,Ptensor, Pscalar,PtraceFree,CurlyA;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y1:=op(YoungTableauBasis([4], [1,2,3,4], output = "Matrix"));
S1:=YoungSymmetrizer(T,Y1);
Ptensor:=ContractIndices(h,S1,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
PtraceFree:=evalDG(Ptensor-1/N*Pscalar*g):
CurlyA:=SymmetrizeIndices(evalDG(6/(N+4)*PtraceFree &t g),[1,2,3,4],"Symmetric");
return CurlyA;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*3*)

Rank4FrankA:=proc(T,g)
local N,h,Y1,S1,Ptensor, Pscalar,PtraceFree,TraceA,CurlyA,FrankA;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y1:=op(YoungTableauBasis([4], [1,2,3,4], output = "Matrix"));
S1:=YoungSymmetrizer(T,Y1);
Ptensor:=ContractIndices(h,S1,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
PtraceFree:=evalDG(Ptensor-1/N*Pscalar*g):
TraceA:=SymmetrizeIndices((3/(N*(N+2))*Pscalar) &mult g &t g,[1,2,3,4],"Symmetric");
CurlyA:=SymmetrizeIndices(evalDG(6/(N+4)*PtraceFree &t g),[1,2,3,4],"Symmetric");
FrankA:=S1 &minus CurlyA &minus TraceA;
return FrankA;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*4*)

Rank4CyrillicB:=proc(T,g)
local N,Y2a,S2,h,Ptensor,SkewP,UpsilonTensorSkew,Bterm1Skew,Bterm2Skew,Bterm3Skew,Bterm4Skew,Bterm5Skew,CyrillicB;
N:=DGinfo("FrameBaseDimension");
Y2a:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[1];
S2:=YoungSymmetrizer(T,Y2a);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S2,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric");
UpsilonTensorSkew:=evalDG(1/N*SkewP-2/(N*(N+2))*SkewP);
Bterm1Skew:=RearrangeIndices(evalDG(2*UpsilonTensorSkew) &t g, [1,4,2,3]);
Bterm2Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[3,1,2,4]);
Bterm3Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[2,1,3,4]);
Bterm4Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[2,4,1,3]);
Bterm5Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[3,4,1,2]);
CyrillicB:=evalDG(Bterm1Skew-Bterm2Skew-Bterm3Skew+Bterm4Skew+Bterm5Skew);
return CyrillicB;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*5*)

Rank4HebrewB:=proc(T,g)
local N,Y2a,S2,h,Ptensor,SymP,UpsilonTensorSym,Bterm1Sym,Bterm2Sym,Bterm3Sym,Bterm4Sym,HebrewB;
N:=DGinfo("FrameBaseDimension");
Y2a:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[1];
S2:=YoungSymmetrizer(T,Y2a);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S2,[[1,1],[2,2]]);
SymP:=SymmetrizeIndices(Ptensor,[1,2],"Symmetric");
UpsilonTensorSym:=evalDG(1/N*SymP);
Bterm1Sym:=RearrangeIndices(UpsilonTensorSym &t g,[3,1,2,4]);
Bterm2Sym:=RearrangeIndices(UpsilonTensorSym &t g,[2,1,3,4]);
Bterm3Sym:=RearrangeIndices(UpsilonTensorSym &t g,[2,4,1,3]);
Bterm4Sym:=RearrangeIndices(UpsilonTensorSym &t g,[3,4,1,2]);
HebrewB:=Bterm3Sym &plus Bterm4Sym &minus Bterm1Sym &minus Bterm2Sym;
return HebrewB;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*6*)

Rank4FrankB:=proc(T,g)
local N,Y2a,S2,h,Ptensor,SkewP,UpsilonTensor,Bterm1,Bterm2,Bterm3,Bterm4,Bterm5,CurlyB,FrankB;
N:=DGinfo("FrameBaseDimension");
Y2a:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[1];
S2:=YoungSymmetrizer(T,Y2a);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S2,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric");
UpsilonTensor:=evalDG(1/N*Ptensor-2/(N*(N+2))*SkewP);
Bterm1:=RearrangeIndices(SymmetrizeIndices(2*UpsilonTensor,[1,2],"SkewSymmetric") &t g, [1,4,2,3]);
Bterm2:=RearrangeIndices(UpsilonTensor &t g,[3,1,2,4]);
Bterm3:=RearrangeIndices(UpsilonTensor &t g,[2,1,3,4]);
Bterm4:=RearrangeIndices(UpsilonTensor &t g,[2,4,1,3]);
Bterm5:=RearrangeIndices(UpsilonTensor &t g,[3,4,1,2]);
CurlyB:=evalDG(Bterm1-Bterm2-Bterm3+Bterm4+Bterm5);
FrankB:=S2 &minus CurlyB;
return FrankB;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*7*)

Rank4CyrillicC:=proc(T,g)
local N,Y2b,S3,h,Ptensor,SkewP,UpsilonTensorSkew,Cterm1Skew,Cterm2Skew,Cterm3Skew,Cterm4Skew,Cterm5Skew,CyrillicC;
N:=DGinfo("FrameBaseDimension");
Y2b:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[2];
S3:=YoungSymmetrizer(T,Y2b);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S3,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric");
UpsilonTensorSkew:=RearrangeIndices(evalDG(1/N*SkewP-2/(N*(N+2))*SkewP),[2,1]);
Cterm1Skew:=RearrangeIndices(evalDG(2*UpsilonTensorSkew) &t g, [1,3,2,4]);
Cterm2Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[2,1,3,4]);
Cterm3Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[2,3,1,4]);
Cterm4Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[4,1,2,3]);
Cterm5Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[4,3,1,2]);
CyrillicC:=evalDG(Cterm1Skew-Cterm2Skew+Cterm3Skew-Cterm4Skew+Cterm5Skew):
return CyrillicC;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*8*)

Rank4HebrewC:=proc(T,g)
local N,Y2b,S3,h,Ptensor,SymP,UpsilonTensorSym,Cterm1Sym,Cterm2Sym,Cterm3Sym,Cterm4Sym,HebrewC;
N:=DGinfo("FrameBaseDimension");
Y2b:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[2];
S3:=YoungSymmetrizer(T,Y2b):
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S3,[[1,1],[2,2]]);
SymP:=SymmetrizeIndices(Ptensor,[1,2],"Symmetric");
UpsilonTensorSym:=RearrangeIndices(evalDG(1/N*SymP),[2,1]);
Cterm1Sym:=RearrangeIndices(UpsilonTensorSym &t g,[2,1,3,4]);
Cterm2Sym:=RearrangeIndices(UpsilonTensorSym &t g,[2,3,1,4]);
Cterm3Sym:=RearrangeIndices(UpsilonTensorSym &t g,[4,1,2,3]);
Cterm4Sym:=RearrangeIndices(UpsilonTensorSym &t g,[4,3,1,2]);
HebrewC:=Cterm2Sym &minus Cterm1Sym &minus Cterm3Sym &plus Cterm4Sym;
return HebrewC;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*9*)

Rank4FrankC:=proc(T,g)
local N,Y2b,S3,h,Ptensor,SkewP,UpsilonTensor,Cterm1,Cterm2,Cterm3,Cterm4,Cterm5,CurlyC,FrankC;
N:=DGinfo("FrameBaseDimension");
Y2b:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[2];
S3:=YoungSymmetrizer(T,Y2b);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S3,[[1,1],[2,2]]);
SkewP:=SymmetrizeIndices(Ptensor,[1,2],"SkewSymmetric");
UpsilonTensor:=RearrangeIndices(evalDG(1/N*Ptensor-2/(N*(N+2))*SkewP),[2,1]):
Cterm1:=RearrangeIndices(SymmetrizeIndices(2*UpsilonTensor,[1,2],"SkewSymmetric") &t g, [1,3,2,4]);
Cterm2:=RearrangeIndices(UpsilonTensor &t g,[2,1,3,4]);
Cterm3:=RearrangeIndices(UpsilonTensor &t g,[2,3,1,4]);
Cterm4:=RearrangeIndices(UpsilonTensor &t g,[4,1,2,3]);
Cterm5:=RearrangeIndices(UpsilonTensor &t g,[4,3,1,2]);
CurlyC:=evalDG(Cterm1-Cterm2+Cterm3-Cterm4+Cterm5);
FrankC:=S3 &minus CurlyC;
return FrankC;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*10*)

Rank4CyrillicD:=proc(T,g)
local N,Y2c,S4,h,Rtensor,SkewR,UpsilonTensorSkew,Dterm1Skew,Dterm2Skew,Dterm3Skew,Dterm4Skew,Dterm5Skew,CyrillicD;
N:=DGinfo("FrameBaseDimension");
Y2c:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[3];
S4:=YoungSymmetrizer(T,Y2c);
h:=InverseMetric(g);
Rtensor:=ContractIndices(h,S4,[[1,1],[2,3]]);
SkewR:=SymmetrizeIndices(Rtensor,[1,2],"SkewSymmetric");
UpsilonTensorSkew:=RearrangeIndices(evalDG(1/N*SkewR-2/(N*(N+2))*SkewR),[2,1]);
Dterm1Skew:=evalDG(2*UpsilonTensorSkew &t g);
Dterm2Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[3,1,2,4]);
Dterm3Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[3,2,1,4]);
Dterm4Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[4,1,2,3]);
Dterm5Skew:=RearrangeIndices(UpsilonTensorSkew &t g,[4,2,1,3]);
CyrillicD:=evalDG(Dterm1Skew-Dterm2Skew+Dterm3Skew-Dterm4Skew+Dterm5Skew);
return CyrillicD;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*11*)

Rank4HebrewD:=proc(T,g)
local N,Y2c,S4,h,Rtensor,SymR,UpsilonTensorSym,Dterm1Sym,Dterm2Sym,Dterm3Sym,Dterm4Sym,HebrewD;
N:=DGinfo("FrameBaseDimension");
Y2c:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[3];
S4:=YoungSymmetrizer(T,Y2c):
h:=InverseMetric(g);
Rtensor:=ContractIndices(h,S4,[[1,1],[2,3]]):
SymR:=SymmetrizeIndices(Rtensor,[1,2],"Symmetric"):
UpsilonTensorSym:=RearrangeIndices(evalDG(1/N*SymR),[2,1]):
Dterm1Sym:=RearrangeIndices(UpsilonTensorSym &t g,[3,1,2,4]):
Dterm2Sym:=RearrangeIndices(UpsilonTensorSym &t g,[3,2,1,4]):
Dterm3Sym:=RearrangeIndices(UpsilonTensorSym &t g,[4,1,2,3]):
Dterm4Sym:=RearrangeIndices(UpsilonTensorSym &t g,[4,2,1,3]):
HebrewD:=Dterm4Sym &minus Dterm1Sym &plus Dterm2Sym &minus Dterm3Sym:
return HebrewD;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*12*)

Rank4FrankD:=proc(T,g)
local N,Y2c,S4,h,Rtensor,SkewR,UpsilonTensor,Dterm1,Dterm2,Dterm3,Dterm4,Dterm5,CurlyD,FrankD;
N:=DGinfo("FrameBaseDimension");
Y2c:=op(YoungTableauBasis([3,1], [1,2,3,4], output = "Matrix"))[3];
S4:=YoungSymmetrizer(T,Y2c);
h:=InverseMetric(g);
Rtensor:=ContractIndices(h,S4,[[1,1],[2,3]]):
SkewR:=SymmetrizeIndices(Rtensor,[1,2],"SkewSymmetric"):
UpsilonTensor:=RearrangeIndices(evalDG(1/N*Rtensor-2/(N*(N+2))*SkewR),[2,1]):
Dterm1:=evalDG(SymmetrizeIndices(2*UpsilonTensor,[1,2],"SkewSymmetric") &t g):
Dterm2:=RearrangeIndices(UpsilonTensor &t g,[3,1,2,4]):
Dterm3:=RearrangeIndices(UpsilonTensor &t g,[3,2,1,4]):
Dterm4:=RearrangeIndices(UpsilonTensor &t g,[4,1,2,3]):
Dterm5:=RearrangeIndices(UpsilonTensor &t g,[4,2,1,3]):
CurlyD:=evalDG(Dterm1-Dterm2+Dterm3-Dterm4+Dterm5);
FrankD:=S4 &minus CurlyD;
return FrankD;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*13*)

Rank4TraceE:=proc(T,g)
local N,h,Y3a,S5,Ptensor,Pscalar,TraceE;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y3a:=op(YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix"))[1];
S5:=YoungSymmetrizer(T,Y3a);
Ptensor:=ContractIndices(h,S5,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
TraceE:=SymmetrizeIndices(SymmetrizeIndices((2/(N*(N-1))*Pscalar) &mult g &t g,[1,3],"SkewSymmetric"),[2,4],"SkewSymmetric");
return TraceE;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*14*)

Rank4CurlyE:=proc(T,g)
local N,h,Y3a,S5,Ptensor,Pscalar,PtraceFree,CurlyE;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y3a:=op(YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix"))[1];
S5:=YoungSymmetrizer(T,Y3a):
Ptensor:=ContractIndices(h,S5,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
PtraceFree:=evalDG(Ptensor-1/N*Pscalar*g);
CurlyE:=SymmetrizeIndices(SymmetrizeIndices(evalDG(4/(N-2)*PtraceFree &t g),[1,3],"SkewSymmetric"),[2,4],"SkewSymmetric");
return CurlyE;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*15*)

Rank4FrankE:=proc(T,g)
local N,h,Y3a,S5,Ptensor,Pscalar,PtraceFree,TraceE,CurlyE,FrankE;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y3a:=op(YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix"))[1];
S5:=YoungSymmetrizer(T,Y3a):
Ptensor:=ContractIndices(h,S5,[[1,1],[2,2]]);
Pscalar:=ContractIndices(h,Ptensor,[[1,1],[2,2]]);
PtraceFree:=evalDG(Ptensor-1/N*Pscalar*g):
TraceE:=SymmetrizeIndices(SymmetrizeIndices((2/(N*(N-1))*Pscalar) &mult g &t g,[1,3],"SkewSymmetric"),[2,4],"SkewSymmetric");
CurlyE:=SymmetrizeIndices(SymmetrizeIndices(evalDG(4/(N-2)*PtraceFree &t g),[1,3],"SkewSymmetric"),[2,4],"SkewSymmetric");
FrankE:=S5 &minus CurlyE &minus TraceE:
return FrankE;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*16*)

Rank4TraceF:=proc(T,g)
local N,h,Y3b,S6,Rtensor,Rscalar,PreTraceF,TraceF;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y3b:=op(YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix"))[2];
S6:=YoungSymmetrizer(T,Y3b);
Rtensor:=ContractIndices(h,S6,[[1,1],[2,3]]);
Rscalar:=ContractIndices(h,Rtensor,[[1,1],[2,2]]);
PreTraceF:=RearrangeIndices((2/(N*(N-1))*Rscalar) &mult g &t g,[1,3,2,4]):
TraceF:=SymmetrizeIndices(SymmetrizeIndices(PreTraceF,[1,2],"SkewSymmetric"),[3,4],"SkewSymmetric");
return TraceF;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*17*)

Rank4CurlyF:=proc(T,g)
local N,h,Y3b,S6,Rtensor,Rscalar,RtraceFree,PreCurlyF,CurlyF;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y3b:=op(YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix"))[2];
S6:=YoungSymmetrizer(T,Y3b):
Rtensor:=ContractIndices(h,S6,[[1,1],[2,3]]);
Rscalar:=ContractIndices(h,Rtensor,[[1,1],[2,2]]);
RtraceFree:=evalDG(Rtensor-1/N*Rscalar*g);
PreCurlyF:=RearrangeIndices(evalDG(4/(N-2)*RtraceFree &t g),[1,3,2,4]):
CurlyF:=SymmetrizeIndices(SymmetrizeIndices(PreCurlyF,[1,2],"SkewSymmetric"),[3,4],"SkewSymmetric");
return CurlyF;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*18*)

Rank4FrankF:=proc(T,g)
local N,h,Y3b,S6,Rtensor,Rscalar,PreTraceF,RtraceFree,TraceF,PreCurlyF,CurlyF,FrankF;
N:=DGinfo("FrameBaseDimension");
h:=InverseMetric(g);
Y3b:=op(YoungTableauBasis([2,2], [1,2,3,4], output = "Matrix"))[2];
S6:=YoungSymmetrizer(T,Y3b):
Rtensor:=ContractIndices(h,S6,[[1,1],[2,3]]);
Rscalar:=ContractIndices(h,Rtensor,[[1,1],[2,2]]);
RtraceFree:=evalDG(Rtensor-1/N*Rscalar*g);
PreTraceF:=RearrangeIndices((2/(N*(N-1))*Rscalar) &mult g &t g,[1,3,2,4]):
TraceF:=SymmetrizeIndices(SymmetrizeIndices(PreTraceF,[1,2],"SkewSymmetric"),[3,4],"SkewSymmetric");
PreCurlyF:=RearrangeIndices(evalDG(4/(N-2)*RtraceFree &t g),[1,3,2,4]):
CurlyF:=SymmetrizeIndices(SymmetrizeIndices(PreCurlyF,[1,2],"SkewSymmetric"),[3,4],"SkewSymmetric");
FrankF:=S6 &minus CurlyF &minus TraceF;
return FrankF;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*19*)

Rank4CurlyG:=proc(T,g)
local N,Y4a,S7,h,Ptensor,Gterm1,Gterm2,Gterm3,CurlyG;
N:=DGinfo("FrameBaseDimension");
Y4a:=op(YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix"))[1];
S7:=YoungSymmetrizer(T,Y4a);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S7,[[1,1],[2,2]]);
Gterm1:=evalDG(g &t Ptensor);
Gterm2:=RearrangeIndices(evalDG(g &t Ptensor),[2,3,1,4]);
Gterm3:=RearrangeIndices(evalDG(g &t Ptensor),[2,4,1,3]);
CurlyG:=evalDG(1/(N-2)*(Gterm1-Gterm2+Gterm3));
return CurlyG;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*20*)

Rank4FrankG:=proc(T,g)
local N,Y4a,S7,h,Ptensor,Gterm1,Gterm2,Gterm3,CurlyG,FrankG;
N:=DGinfo("FrameBaseDimension");
Y4a:=op(YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix"))[1];
S7:=YoungSymmetrizer(T,Y4a);
h:=InverseMetric(g);
Ptensor:=ContractIndices(h,S7,[[1,1],[2,2]]);
Gterm1:=evalDG(g &t Ptensor);
Gterm2:=RearrangeIndices(evalDG(g &t Ptensor),[2,3,1,4]);
Gterm3:=RearrangeIndices(evalDG(g &t Ptensor),[2,4,1,3]);
CurlyG:=evalDG(1/(N-2)*(Gterm1-Gterm2+Gterm3));
FrankG:=S7 &minus CurlyG;
return FrankG;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*21*)

Rank4CurlyH:=proc(T,g)
local N,Y4b,S8,h,Rtensor,Hterm1,Hterm2,Hterm3,CurlyH;
N:=DGinfo("FrameBaseDimension");
Y4b:=op(YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix"))[2];
S8:=YoungSymmetrizer(T,Y4b);
h:=InverseMetric(g);
Rtensor:=ContractIndices(h,S8,[[1,1],[2,3]]);
Hterm1:=RearrangeIndices(evalDG(g &t Rtensor),[1,3,2,4]);
Hterm2:=RearrangeIndices(evalDG(g &t Rtensor),[2,3,1,4]);
Hterm3:=evalDG(Rtensor &t g);
CurlyH:=evalDG(1/(N-2)*(Hterm1-Hterm2+Hterm3));
return CurlyH;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*22*)

Rank4FrankH:=proc(T,g)
local N,Y4b,S8,h,Rtensor,Hterm1,Hterm2,Hterm3,CurlyH,FrankH;
N:=DGinfo("FrameBaseDimension");
Y4b:=op(YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix"))[2];
S8:=YoungSymmetrizer(T,Y4b);
h:=InverseMetric(g);
Rtensor:=ContractIndices(h,S8,[[1,1],[2,3]]);
Hterm1:=RearrangeIndices(evalDG(g &t Rtensor),[1,3,2,4]);
Hterm2:=RearrangeIndices(evalDG(g &t Rtensor),[2,3,1,4]);
Hterm3:=evalDG(Rtensor &t g);
CurlyH:=evalDG(1/(N-2)*(Hterm1-Hterm2+Hterm3));
FrankH:=S8 &minus CurlyH;
return FrankH;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*23*)

Rank4CurlyJ:=proc(T,g)
local N,Y4c,S9,h,Utensor,Jterm1,Jterm2,Jterm3,CurlyJ;
N:=DGinfo("FrameBaseDimension");
Y4c:=op(YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix"))[3];
S9:=YoungSymmetrizer(T,Y4c);
h:=InverseMetric(g);
Utensor:=ContractIndices(h,S9,[[1,1],[2,4]]);
Jterm1:=RearrangeIndices(evalDG(g &t Utensor),[1,4,2,3]);
Jterm2:=RearrangeIndices(evalDG(g &t Utensor),[2,4,1,3]);
Jterm3:=evalDG(Utensor &t g);
CurlyJ:=evalDG(1/(N-2)*(Jterm1-Jterm2+Jterm3));
return CurlyJ;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*24*)

Rank4FrankJ:=proc(T,g)
local N,Y4c,S9,h,Utensor,Jterm1,Jterm2,Jterm3,CurlyJ,FrankJ;
N:=DGinfo("FrameBaseDimension");
Y4c:=op(YoungTableauBasis([2,1,1], [1,2,3,4], output = "Matrix"))[3];
S9:=YoungSymmetrizer(T,Y4c);
h:=InverseMetric(g);
Utensor:=ContractIndices(h,S9,[[1,1],[2,4]]);
Jterm1:=RearrangeIndices(evalDG(g &t Utensor),[1,4,2,3]);
Jterm2:=RearrangeIndices(evalDG(g &t Utensor),[2,4,1,3]);
Jterm3:=evalDG(Utensor &t g);
CurlyJ:=evalDG(1/(N-2)*(Jterm1-Jterm2+Jterm3));
FrankJ:=S9 &minus CurlyJ;
return FrankJ;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*25*)

Rank4FrankK:=proc(T,g)
local N,Y5,S10;
N:=DGinfo("FrameBaseDimension");
Y5:=op(YoungTableauBasis([1,1,1,1], [1,2,3,4], output = "Matrix"));
S10:=YoungSymmetrizer(T,Y5);
return S10;
end proc:

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*26*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*27*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*28*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*29*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*30*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*31*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*32*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*33*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*34*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*35*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*36*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*37*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*38*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*39*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*40*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*41*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*42*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*43*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*44*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*45*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*46*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*47*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*48*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*49*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*50*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*51*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*52*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*53*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*54*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*55*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*56*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*57*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*58*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*59*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*60*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*61*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*62*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*63*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*64*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*65*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*66*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*67*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*68*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*69*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*70*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*71*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*72*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*73*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*74*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*75*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*76*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*77*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*78*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*79*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*80*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*81*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*82*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*83*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*84*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*85*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*86*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*87*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*88*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*89*)

#1111111111111111111111111111111111111111111111111111111111111111111111
#(*90*)


#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111
#1111111111111111111111111111111111111111111111111111111111111111111111

end module: